<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }
//	License for all code of this FreePBX module can be found in the license file inside the module directory
//	Copyright 2013 Schmooze Com Inc.
//
$get_vars = array(
	'action'	=> '',
	'submit'	=> '',
	'username' => '', //Bria API Username
	'password' => '', //Bria API Password
	'prefix' => '', //Bria Device Prefix
	'ipaddr' => '', //IP or FQDN of this PBX
	'web_browser_enable' => 0,
	'web_browser_name' => '',
	'web_browser_url' => '',
);

foreach ($get_vars as $k => $v) {
	$var[$k] = isset($_REQUEST[$k]) ? $_REQUEST[$k] : $v;
}

$action = $var['action'];
$oldPrefix = FreePBX::Bria()->getPrefix();
$oldWebBrowserEnable = FreePBX::Bria()->getSetting('web_browser_enable');
$oldWebBrowserName = FreePBX::Bria()->getSetting('web_browser_name');
$oldWebBrowserUrl = FreePBX::Bria()->getSetting('web_browser_url');

//action actions
switch ($action) {
	case 'save':
		//Unset any settings not needed
		unset($var['action'], $var['submit']);

		FreePBX::Bria()->setMultipleSettings($var);
		break;
}

//view action
switch ($action) {
	case 'edit':
	case 'save':
	default:
		$groupResponse = null;

		$bria_admin_settings['limits'] = array(
			'numUsers' =>	0,
			'maxUsers' =>	0,
			'deviceLimit' => 0,
			'deviceCount' => 0,
			'desktopLimit' => 0,
			'desktopCount' => 0,
			'phoneLimit' => 0,
			'phoneCount' => 0,
			'tabletLimit' => 0,
			'tabletCount' => 0,
		);

		//Get bria admin information and populate our view
		$bria_admin_settings = array(
			'username' => FreePBX::Bria()->getSetting('username'),
			'password' => FreePBX::Bria()->getSetting('password'),
			'prefix' => FreePBX::Bria()->getPrefix(),
			'ipaddr' => FreePBX::Bria()->getSetting('ipaddr'),
			'users' => FreePBX::Bria()->getAllUsers(),
			'groupname' => FreePBX::Bria()->getSetting('groupname'),
			'web_browser_enable' => FreePBX::Bria()->getSetting('web_browser_enable'),
			'web_browser_name' => FreePBX::Bria()->getSetting('web_browser_name'),
			'web_browser_url' => FreePBX::Bria()->getSetting('web_browser_url')
		);

		$recreateBasedOnOldPrefix = ($oldPrefix !== $bria_admin_settings['prefix']);

		$recreateBasedOnWebBrowserChange = false;
		if ($oldWebBrowserEnable !== $bria_admin_settings['web_browser_enable'] ||
			$oldWebBrowserName !== $bria_admin_settings['web_browser_name'] ||
			$oldWebBrowserUrl !== $bria_admin_settings['web_browser_url']) {
			$recreateBasedOnWebBrowserChange = true;
		}
		//If the prefix changed, update all the devices
		if ($recreateBasedOnOldPrefix) {
			FreePBX::Bria()->updatePrefix($oldPrefix);
		} else if ($recreateBasedOnWebBrowserChange) {
			FreePBX::Bria()->updateBriaUserSettings();
		}

		//TODO: Fix the code below
		if (!empty($bria_admin_settings['username']) && !empty($bria_admin_settings['password'])) {
			try {
				$bria = new PestBria($bria_admin_settings['username'], $bria_admin_settings['password']);

				$groupResponse = $bria->getGroup(array('groupName' => 'all'));

				if ($groupResponse->attributes()->resultCode) {
					$bria_admin_settings['message'] = array(
						'type' => 'danger',
						'message' => $groupResponse->attributes()->resultCode . ' - ' . $groupResponse[0],
					);
					$bria_admin_settings['connection'] = _('Connected with errors');
				}
			} catch (Pest_Unauthorized $e) {
				$bria_admin_settings['message'] = array(
					'type' => 'danger',
					'message' => _('Account Login/Provisioning Code is incorrect. Please try again.'),
				);
			} catch (Exception $e) {
				$bria_admin_settings['message'] = array(
					'type' => 'danger',
					'message' => $e->getMessage(),
				);
			}

			if (empty($bria_admin_settings['message'])) {
				$bria_admin_settings['connection'] = _('Connected');
			} else if (!empty($bria_admin_settings['message']) && empty($bria_admin_settings['connection'])) {
				$bria_admin_settings['connection'] = _('Disconnected');
			}

			if (is_object($groupResponse) && isset($groupResponse->CcsUserGroup)) {
				$tmpGroupName = $groupResponse->CcsUserGroup->attributes()->groupName;
				//check if we have a groupname or if the settings don't match from what we have in the database
				if (empty($bria_admin_settings['groupname']) || $bria_admin_settings['groupname'] != $tmpGroupName) {
					//ensure we set it in the db for future use
					$bria_admin_settings['groupname'] = $tmpGroupName;
					FreePBX::Bria()->setSetting('groupname', $bria_admin_settings['groupname']);
				}
				$bria_admin_settings['limits'] = array(
					'numUsers' =>	isset($groupResponse->CcsUserGroup->attributes()->numUsers) ? $groupResponse->CcsUserGroup->attributes()->numUsers : 0,
					'maxUsers' =>	isset($groupResponse->CcsUserGroup->attributes()->maxUsers) ? $groupResponse->CcsUserGroup->attributes()->maxUsers : 0,
				);

				if (!empty($groupResponse->CcsUserGroup->CcsGroupLimit)) {
					$bria_admin_settings['limits']['groupLimit'] = true;
					$bria_admin_settings['limits']['deviceLimit'] = isset($groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->deviceLimit) ? $groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->deviceLimit : 0;
					$bria_admin_settings['limits']['deviceCount'] = isset($groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->deviceCount) ? $groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->deviceCount : 0;
					$bria_admin_settings['limits']['desktopLimit'] = isset($groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->desktopLimit) ? $groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->desktopLimit : 0;
					$bria_admin_settings['limits']['desktopCount'] = isset($groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->desktopCount) ? $groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->desktopCount : 0;
					$bria_admin_settings['limits']['phoneLimit'] = isset($groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->phoneLimit) ? $groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->phoneLimit : 0;
					$bria_admin_settings['limits']['phoneCount'] = isset($groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->phoneCount) ? $groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->phoneCount : 0;
					$bria_admin_settings['limits']['tabletLimit'] = isset($groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->tabletLimit) ? $groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->tabletLimit : 0;
					$bria_admin_settings['limits']['tabletCount'] = isset($groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->tabletCount) ? $groupResponse->CcsUserGroup->CcsGroupLimit->attributes()->tabletCount : 0;
				}
			}
		}

		echo load_view(dirname(__FILE__) . '/views/admin.php', $bria_admin_settings);
		break;
}
