<div class="panel panel-info">
	<div class="panel-heading">
		<div class="panel-title">
			<a href="#" data-toggle="collapse" data-target="#moreinfo-xmpp"><i class="glyphicon glyphicon-info-sign"></i></a>&nbsp;&nbsp;&nbsp;<?php echo _("What is Bria")?>
		</div>
	</div>
	<!--At some point we can probably kill this... Maybe make is a 1 time panel that may be dismissed-->
	<div class="panel-body collapse" id="moreinfo-xmpp">
		<p><?php echo _('This module manages and configures Bria Cloud Solutions')?></p>
	</div>
</div>
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="bria_enable"><?php echo _('Enabled')?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="bria_enable"></i>
					</div>
					<div class="col-md-9">
						<span class="radioset">
							<input type="radio" id="bria1" name="bria|enable" value="true" <?php echo ($enabled) ? 'checked' : ''; ?>><label for="bria1"><?php echo _('Yes'); ?></label>
							<input type="radio" id="bria2" name="bria|enable" value="false" <?php echo (!is_null($enabled) && !$enabled) ? 'checked' : ''; ?>><label for="bria2"><?php echo _('No'); ?></label>
							<?php if($mode == "user") {?>
								<input type="radio" id="bria3" name="bria|enable" value='inherit' <?php echo is_null($enabled) ? 'checked' : ''; ?>>
								<label for="bria3"><?php echo _('Inherit')?></label>
							<?php } ?>
						</span>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="bria_enable-help" class="help-block fpbx-help-block"><?php echo _("Should this user have a Bria Cloud Solutions extension associated with it? Defaults to No")?></span>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="bria_transport"><?php echo _('Transport')?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="bria_transport"></i>
					</div>
					<div class="col-md-9">
						<span class="radioset">
							<input type="radio" id="bria3" name="bria|transport" value="udp" <?php echo ($transport === 'udp') ? 'checked' : ''; ?>><label for="bria3"><?php echo _('UDP'); ?></label>
							<input type="radio" id="bria4" name="bria|transport" value="tcp" <?php echo ($transport === 'tcp') ? 'checked' : ''; ?>><label for="bria4"><?php echo _('TCP'); ?></label>
							<input type="radio" id="bria5" name="bria|transport" value="tls" <?php echo ($transport === 'tls') ? 'checked' : ''; ?>><label for="bria5"><?php echo _('TLS'); ?></label>
						</span>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="bria_transport-help" class="help-block fpbx-help-block"><?php echo _("What transport should this extension use with Bria Cloud Solutions? Defaults to UDP")?></span>
		</div>
	</div>
</div>
<script>
var briaHandler = function( event ) {
	var invalidCharacters = /[;/\?:@&=+\$,\\]/;
	var password = $('input[name="password"]');

	if(password.val() == '******') {
		alert('<?php echo _('You enabled Bria Cloud Solutions but did not change your password')?>');
		password.focus();
		event.preventDefault();
		return false;
	} else if (invalidCharacters.test(password.val())) {
		alert('<?php echo _('Due to restrictions with Bria Cloud Solutions, your password cannot contain the following characters: ,;/\?:@&=+$')?>');
		password.focus();
		event.preventDefault();
		return false;
	}
};

$('#bria1').click(function() {
	if($('#bria1').data("checked")) {
		return;
	}
	var r=confirm('<?php echo _('Enabling Bria requires you to redefine your password(s) and will expose your password in the database')?>');
	if(r==false){
		$('#bria2').click();
	} else {
		$('input[name="password"]').focus();
		$('form[name="editM"]').on('submit',briaHandler);
	}
})
$('#bria2').click(function() {
	$('form[name="editM"]').off('submit',briaHandler);
})
</script>
