<?php
namespace FreePBX\modules;

class Broadcast implements \BMO {
	public function __construct($freepbx = null) {
		if ($freepbx == null) {
			throw new Exception("Not given a FreePBX Object");
		}
		$this->FreePBX = $freepbx;
		$this->db = $freepbx->Database;
	}
  public function install() {}
  public function uninstall() {}
  public function backup() {}
  public function restore($backup) {}
  public function doConfigPageInit($page) {
    $rvars = array("action", "number", "name", "callee_name", "callee_number", "speeddial", "gensd", "ftpdelete",
    	"editcampaign", "addcampaign", "addgroup", "editgroup", "editCallee", "campaign", "from_email",
    	"concurrent_calls", "maximum_retry", "active_campaigns", "id", "duplicate", "updateperiod", "uri");

    foreach ($rvars as $var) {
    	if (isset($_REQUEST[$var])) {
    		$$var = $_REQUEST[$var];
    	} else {
    		$$var = '';
    	}
    }
    if($action) {
    	switch ($action) {
    		case "delcamp":
    			if ($campaign) {
            $this->delCampaign($campaign);
    			}
    			break;
    		case "abort":
    			if ($campaign) {
            $this->abortCampaign($campaign);
    			}
    			break;
    		case "restart":
    			if ($campaign) {
    				$this->restartCampaign($campaign);
    			}
    			break;
    		case "report":
    			$data = $this->reportCSV($campaign);
    			$campaign_name = $this->getNamebyId($campaign);
    			$filename = "broadcast_report_${campaign_name}_".date("Ymd").".csv";
    			\broadcast_csv_download($data, $filename, "text/csv");
    			exit;
    		case "settings":
    			\broadcast_savesettings($concurrent_calls, $maximum_retry, $active_campaigns, $from_email);
    		case "deleteCallee":
    			\broadcast_deleteCallee($id);
    			break;
				case "editCallee":
					dbug($editCallee,$id,$callee_name,$callee_number);
					$group_id = $id;
					if($editCallee)  {
						\broadcast_editCallee($editCallee,$callee_name,$callee_number);
						}
					else if($callee_number)  {
						\broadcast_addCallee($group_id,$callee_name,$callee_number);
						}
					break;
				case "deleteCampaign":
					\broadcast_deleteCampaign($_REQUEST['edit']);
					$_REQUEST['editcampaign'] = NULL;
					$_REQUEST['delete'] = NULL;
					$_REQUEST['edit'] = NULL;
					$_REQUEST['action'] = '';
				break;
    		case "campaign":
    			if($duplicate) {
    				$editcampaign = \broadcast_duplicate_campaign($duplicate);
						$_REQUEST['addcampaign'] = NULL;
						$_REQUEST['editcampaign'] = $editcampaign;
    				break;
    			}

    			$campaign = array(
    							"name" 					=> $_REQUEST['campaignName'],
    							"email" 				=> $_REQUEST['campaignEmail'],
    							"email_settings" 		=> $_REQUEST['email_settings'],
    							"active" 				=> $_REQUEST['active'],
    							"dupes" 				=> 1,
    							"time_start" 			=> hma_to_sql($_REQUEST['start_time_hour'],
    																$_REQUEST['start_time_minute'],
    																$_REQUEST['start_time_ampm']),
    							"time_finish" 			=> hma_to_sql($_REQUEST['end_time_hour'],
    																$_REQUEST['end_time_minute'],
    																$_REQUEST['end_time_ampm']),
    							"weekday_start" 		=> $_REQUEST['start_week_day'],
    							"weekday_finish" 		=> $_REQUEST['end_week_day'],
    							"date_start" 			=> date_to_sql($_REQUEST['start_date_month'],
    																$_REQUEST['start_date_day'],
    																$_REQUEST['start_date_year']),
    							"date_finish"			=> date_to_sql($_REQUEST['end_date_month'],
    																$_REQUEST['end_date_day'],
    																$_REQUEST['end_date_year']),
    							"destination_person"	=> $_REQUEST[$_REQUEST['goto1']."1"],
    							"destination_machine"	=> $_REQUEST[$_REQUEST['goto2']."2"],
    							"callerid"				=> $_REQUEST['campaignCallerid'],
    							"prefix"				=> $_REQUEST['campaignPrefix'],
    							"concurrentcalls"		=> $_REQUEST['concurrentcalls']
    					);
    			$id = "";
    			if(isset($_REQUEST['delete']))  {
    				\broadcast_deleteCampaign($_REQUEST['edit']);
						$_REQUEST['editcampaign'] = NULL;
						$_REQUEST['delete'] = NULL;
						$_REQUEST['edit'] = NULL;
						$_REQUEST['action'] = '';
    			}
    			else if($_REQUEST['edit']) {
    				\broadcast_editCampaign($_REQUEST['edit'],$campaign);
    				$id = $_REQUEST['edit'];
    			}
    			else  {
    				$id = \broadcast_addCampaign($campaign);
						$_REQUEST['addcampaign'] = NULL;
						$_REQUEST['editcampaign'] = $id;
    			}
    			if($id)  {
    				\broadcast_deletecallgroups($id);
    				\broadcast_addcallgroups($id,$_REQUEST['active_groups']);
    			}
    			needreload();
    			break;
    		case "group":
    			$group_id = "";
    			if($_REQUEST['edit'] != "false")  { // this group was edited
    				if(isset($_REQUEST['delete']))  {
    					\broadcast_deleteGroup($_REQUEST['edit']);
							$_REQUEST['editgroup'] = NULL;
							$_REQUEST['edit'] = NULL;
							$_REQUEST['delete'] = NULL;
    				}
    				else  {
    					\broadcast_editGroup($_REQUEST['edit'],$_REQUEST['name']);
    					$group_id = $_REQUEST['edit'];
    					$editgroup = $group_id;
    				}
    			}
    			else  { // this is a new group
    				$group_id = \broadcast_addGroup($_REQUEST['name']);
    				$editgroup = $group_id; // bring the user back to this screen to add/edit callees
    				$_REQUEST['addgroup'] = NULL;
						$_REQUEST['editgroup'] = $group_id;
					}
    			if($editCallee)  {
    				\broadcast_editCallee($editCallee,$callee_name,$callee_number);
    			}
    			else if($callee_number)  {
    				\broadcast_addCallee($group_id,$callee_name,$callee_number);
    			}
    			$i = 0; // imported lines
    			if(is_uploaded_file($_FILES['csv']['tmp_name'])) {
    				include __DIR__.'/enc/Importer.class.php';
    				$i = new \Importer();
    				$csvfile = fopen($_FILES['csv']['tmp_name'], 'r');
    				$data = $i->importCSV($csvfile);
    				unlink($_FILES['csv']['tmp_name']);
    				if (is_array($data)) {
    					$i->updateCG($group_id, $data, "ABC");
    				} else {
    					print "Error importing CSV File: $data";
    				}
    			} else  {
    				$n = 0; // total lines if no file
    			}
        		break;
    		case "export":
    			$group_name = $db->getOne("SELECT name FROM broadcast_groups WHERE id='".$_REQUEST['group']."'");
    			header('Content-Type: text/csv');
    			header("Content-disposition: attachment; filename=$group_name.csv");
    			$numbers = \broadcast_calleeList($_REQUEST['group']);
    			foreach ($numbers as $number => $values)  {
    				printf("\"%s\",\"%s\"\n", $values['name'], $values['phonenum']);
    			}
    			exit;
    			break;
    	}
    }
  }
	public function getActionBar($request) {
		$buttons = array();
		switch($request['display']) {
			case 'broadcast':
				$buttons = array(
					'reset' => array(
						'name' => 'reset',
						'id' => 'reset',
						'value' => _('Reset')
					),
					'submit' => array(
						'name' => 'submit',
						'id' => 'submit',
						'value' => _('Submit')
					)
				);
				if (isset($request['editcampaign']) || isset($request['editgroup'])) {
					$buttons['delete'] =  array(
						'name' => 'delete',
						'id' => 'delete',
						'value' => _('Delete')
					);
				}
			break;
		}
		return $buttons;
	}
  public function ajaxRequest($req, &$setting) {
    switch ($req) {
      case 'getJSON':
			case 'campaignSwitch':
        return true;
      break;
      default:
        return false;
      break;
    }
  }
  public function ajaxHandler(){
    switch ($_REQUEST['command']) {
      case 'getJSON':
        switch ($_REQUEST['jdata']) {
          case 'campgrid':
            return array_values($this->campaignList());
          break;
          case 'groupgrid':
            return array_values($this->groupList());
          break;
          default:
            return false;
          break;
        }
      break;
			case 'campaignSwitch':
				$id = isset($_REQUEST['id'])?$_REQUEST['id']:false;
				$state = isset($_REQUEST['state'])?$_REQUEST['state']:false;
				if($id && $state){
					switch ($state) {
						case 'yes':
							return $this->markCampaignActive($id);
						break;
						case 'no':
							return $this->markCampaignInactive($id);
						break;
					}
				}
				return false;
			break;
      default:
        return false;
      break;
    }
  }
  public function delCampaign($campaign){
    if ($campaign == 'NULL') { // the actual string..
      $sql = "DELETE FROM broadcast_log WHERE uniqueid IS NULL";
      $stmt = $this->db->prepare($sql);
      return $stmt->execute();
    } else {
      $sql = "DELETE FROM broadcast_log WHERE uniqueid = ?";
      $stmt = $this->db->prepare($sql);
      return $stmt->execute(array($campaign));
    }
  }
  public function abortCampaign($campaign){
    $sql = "UPDATE broadcast_campaigns SET completed=1,active=0 WHERE id = ?";
    $stmt = $this->db->prepare($sql);
    return $stmt->execute(array($campaign));
  }
  public function restartCampaign($campaign){
    $sql = "UPDATE broadcast_campaigns SET completed=0,active=0,uniqueid='' WHERE id = ?";
    $stmt = $this->db->prepare($sql);
    return $stmt->execute(array($campaign));
  }
  public function getNamebyId($id){
    $sql = "SELECT name FROM broadcast_campaigns WHERE id = ?";
    $stmt = $this->db->prepare($sql);
    $stmt->execute(array($id));
    return $stmt->fetchColumn();
  }
  public function campaignList($id = null){
    $sql = "SELECT * FROM broadcast_campaigns";
    if($id)  {
      $sql .= " WHERE id= ?";
      $stmt = $this->db->prepare($sql);
      $stmt->execute(array($id));
    }else {
      $stmt = $this->db->prepare($sql);
      $stmt->execute();
    }
    $ret = $stmt->fetchAll(\PDO::FETCH_ASSOC);
    if(is_array($ret)){
      return $ret;
    }else {
      return array();
    }
  }
  public function groupList(){
    $sql = "SELECT * FROM broadcast_groups";
    $stmt = $this->db->prepare($sql);
    $stmt->execute();
    $ret = $stmt->fetchAll(\PDO::FETCH_ASSOC);
    if(is_array($ret)){
      return $ret;
    }else {
      return array();
    }
  }
	public function reportCSV($campaign){
		if (!class_exists("Service")) {
			include "enc/Service.class.php";
		}
		$s = new \Service();
		$calls = $s->getCalls($campaign);
		$data = "last_updated,campaign,callee_name,callee_number,initiated_dial,answer,delivered_to\n";
		foreach ($calls as $line) {
			$data .= implode(",", $line)."\n";
		}
		return $data;
	}
	public function markCampaignActive($id){
		$sql = "UPDATE broadcast_campaigns SET active='1' WHERE id=?";
		$stmt = $this->db->prepare($sql);
		return $stmt->execute(array($id));
	}
	public function markCampaignInactive($id){
		$sql = "UPDATE broadcast_campaigns SET active='0' WHERE id=?";
		$stmt = $this->db->prepare($sql);
		return $stmt->execute(array($id));
	}
	public function getRightNav($request) {
		if(isset($request['addgroup'])||isset($request['editgroup'])||isset($request['addcampaign'])||isset($request['editcampaign'])){
    	return load_view(__DIR__."/views/bootnav.php",array('request' => $request));
		}
	}
}
