<?php
if(sizeof($groups) == 0 && (isset($_REQUEST['editcampaign']) || isset($_REQUEST['addcampaign'])))  {
	echo "<h2>"._("You need to add a call group before you can add a campaign.")."</h2>";
	echo "<p><a href=\"config.php?display=broadcast&addgroup=true\" class=\"btn btn-default\"><i class='fa fa-plus'></i> ". _("Add a Call Group")."</a></p>";
}else if($editcampaign || $addcampaign)  {
	if($editcampaign)  { // Edit
		$t = broadcast_campaignList($editcampaign);
		$campaign = $t[0];
		$campaignName = htmlentities($campaign['name'],ENT_COMPAT | ENT_HTML401, "UTF-8");
		$campaignEmail = htmlentities($campaign['email'],ENT_COMPAT | ENT_HTML401, "UTF-8");
		$campaignPrefix = htmlentities($campaign['prefix'],ENT_COMPAT | ENT_HTML401, "UTF-8");
		$campaignCallerid = htmlentities($campaign['callerid'],ENT_COMPAT | ENT_HTML401, "UTF-8");
		$concurrentcalls = htmlentities($campaign['concurrentcalls'],ENT_COMPAT | ENT_HTML401, "UTF-8");
		$email_settings = $campaign['email_settings'];
		$active = $campaign['active'];
		list($start_time_hour,$start_time_minute,$start_time_ampm) = sql_to_hma($campaign['time_start']);
		list($end_time_hour,$end_time_minute,$end_time_ampm) = sql_to_hma($campaign['time_finish']);
		list($start_date_month,$start_date_day,$start_date_year) = sql_to_date($campaign['date_start']);
		list($end_date_month,$end_date_day,$end_date_year) = sql_to_date($campaign['date_finish']);
		$start_week_day = $campaign['weekday_start'];
		$end_week_day = $campaign['weekday_finish'];
		$destination_person = $campaign['destination_person'];
		$destination_machine = $campaign['destination_machine'];
		$dupes = $campaign['dupes'];
		$delURL = '?display=broadcast&action=deleteCampaign&edit='.$editcampaign;
	}else  { // pre-populate on "Add"
		$campaignName = "";
		$campaignEmail ="";
		$campaignCallerid = "";
		$email_settings = "";
		$active = "0"; // Do not auto-activate.
		$concurrentcalls = "2";
		$start_time_hour = "8";
		$start_time_minute = "0";
		$start_time_ampm = "AM";
		$end_time_hour = "5";
		$end_time_minute = "0";
		$end_time_ampm = "PM";
		$start_date_month = date("n");
		$start_date_day = date("j");
		$start_date_year = date("Y");
		$end_date_month = date("n");
		$end_date_day = date("j");
		$end_date_year = date("Y")+1;
		$start_week_day = "";
		$end_week_day = "";
		$destination_person = "";
		$destination_machine = "";
		$dupes = "1"; // Always avoid dupes.
		$delURL = '';
	}
	$callgroupopts = '';
if(isset($groups))  {
  foreach($groups as $group){
    $selected = (broadcast_isgroupincampaign($group['id'],$editcampaign))?'SELECTED':'';
		$callgroupopts .= '<option value = "'.$group['id'].'" '.$selected.'>'.$group['name'].'</option>';
  }
}
$hour_options = "";
$minute_options = "";
$month_options = "";
$day_options = "";
$year_options = "";
function hour_options($current=null)  {
  $hour_options = "";
  for($i = 1; $i <= 12; $i++)  {
    $hour_options .= "<option value=\"$i\"".($i == $current?" selected":"").">$i</option>";
  }
  return $hour_options;
}
function minute_options($current=null)  {
  $minute_options = "";
  for($i = 0; $i < 60; $i++)  {
    $p = str_pad($i, 2, "0", STR_PAD_LEFT);
    $minute_options .= "<option value=\"$i\"".($i == $current?" selected":"").">$p</option>";
  }
  return $minute_options;
}
function month_options($current=null)  {
  $month_options = "";
  for($i = 0; $i <=12; $i++)  {
    $m = date("F",mktime(0,0,0,$i,1,date("y")));
    $month_options .= "<option value=\"$i\"".($i == $current?" selected":"").">$m</option>";
  }
  return $month_options;
}
function day_options($current=null)  {
  $day_options = "";
  for($i = 1; $i <= 31; $i++)  {
    $day_options .= "<option value=\"$i\"".($i == $current?" selected":"").">$i</option>";
  }
  return $day_options;
}
function year_options($current=null)  {
  $year_options = "";
  for($i = 2009; $i <= date("Y")+2; $i++)  {
    $year_options .= "<option value=\"$i\"".($i == $current?" selected":"").">$i</option>";
  }
  return $year_options;
}

?>
<form autocomplete="off" name="editCampaign" id="editCampaign" action="" method="post" class="fpbx-submit" onsubmit="return editCampaign_onsubmit();" data-fpbx-delete="<?php echo $delURL?>">
	<input type="hidden" name="display" value="broadcast">
	<input type="hidden" name="action" value="campaign">
	<input type="hidden" name="edit" value="<?php echo $editcampaign?>">
  <!--Duplicate Campaign-->
  <div class="element-container <?php echo $addcampaign?'':'hidden'?>">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="duplicate"><?php echo _("Duplicate Campaign") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="duplicate"></i>
            </div>
            <div class="col-md-9">
              <select class="form-control" id="duplicate" name="duplicate" onchange="document.editCampaign.submit()">
                <option value=""> <?php echo _("None")?> </option>
                <?php
                  foreach($campaigns as $campaign)  {
                    echo "<option value='".$campaign['id']."'>".$campaign['name']."</option>";
                  }
                ?>
              </select>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="duplicate-help" class="help-block fpbx-help-block"><?php echo _("You can choose to dublicate an existing campaign.  Select the campaign you wish to duplicate, then click Save.  This allows you to run the same campaign after it is completed while keeping previous campaign reports intact.")?></span>
      </div>
    </div>
  </div>
  <!--END Duplicate Campaign-->
  <!--Campaign Name-->
  <div class="element-container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="campaignName"><?php echo _("Campaign Name") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="campaignName"></i>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="campaignName" name="campaignName" value="<?php echo isset($campaignName)?$campaignName:''?>">
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="campaignName-help" class="help-block fpbx-help-block"><?php echo _("Enter the name for this campaign")?></span>
      </div>
    </div>
  </div>
  <!--END Campaign Name-->
  <!--Concurrent Calls-->
  <div class="element-container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="concurrentcalls"><?php echo _("Concurrent Calls") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="concurrentcalls"></i>
            </div>
            <div class="col-md-9">
              <input type="number" class="form-control" id="concurrentcalls" name="concurrentcalls" value="<?php echo isset($concurrentcalls)?$concurrentcalls:'2'?>">
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="concurrentcalls-help" class="help-block fpbx-help-block"><?php echo _("Maximum concurrent calls that this campaign can use")?></span>
      </div>
    </div>
  </div>
  <!--END Concurrent Calls-->
  <!--Campaign Caller ID-->
  <div class="element-container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="campaignCallerid"><?php echo _("Campaign Caller ID") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="campaignCallerid"></i>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="campaignCallerid" name="campaignCallerid" value="<?php echo isset($campaignCallerid)?$campaignCallerid:''?>">
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="campaignCallerid-help" class="help-block fpbx-help-block"><?php echo _("Enter the caller id you would like to use for this campaign")?></span>
      </div>
    </div>
  </div>
  <!--END Campaign Caller ID-->
  <!--Dial Prefix-->
  <div class="element-container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="campaignPrefix"><?php echo _("Dial Prefix") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="campaignPrefix"></i>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="campaignPrefix" name="campaignPrefix" value="<?php echo isset($campaignPrefix)?$campaignPrefix:''?>">
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="campaignPrefix-help" class="help-block fpbx-help-block"><?php echo _("Prefix to be appended to every number before dialed - useful to force calles out a specific Outbound Route")?></span>
      </div>
    </div>
  </div>
  <!--END Dial Prefix-->
  <!--Email Reports to-->
  <div class="element-container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="campaignEmail"><?php echo _("Email Reports to") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="campaignEmail"></i>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="campaignEmail" name="campaignEmail" value="<?php echo isset($campaignEmail)?$campaignEmail:''?>">
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="campaignEmail-help" class="help-block fpbx-help-block"><?php echo _("Enter the email address you wish this report to be emailed to")?></span>
      </div>
    </div>
  </div>
  <!--END Email Reports to-->
  <!--Email Reports-->
  <div class="element-container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="email_settings"><?php echo _("Email Reports") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="email_settings"></i>
            </div>
            <div class="col-md-9 radioset">
              <input type="radio" name="email_settings" id="email_settingsnever" value="" <?php echo ($email_settings == ""?"CHECKED":"") ?>>
              <label for="email_settingsnever"><?php echo _("Never");?></label>
              <input type="radio" name="email_settings" id="email_settingsdaily" value="daily" <?php echo ($email_settings == "daily"?"CHECKED":"") ?>>
              <label for="email_settingsdaily"><?php echo _("Daily After End Time");?></label>
              <input type="radio" name="email_settings" id="email_settingscompletion" value="completion" <?php echo ($email_settings == "completion"?"CHECKED":"") ?>>
              <label for="email_settingscompletion"><?php echo _("After Campaign Completes");?></label>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="email_settings-help" class="help-block fpbx-help-block"><?php echo _("Choose Daily After End Time to have a report emailed each day after the End Time is reached (see below) and also after the campaign is completed.  Choose After Campaign Completes to receive an email only after the campaign is completed.")?></span>
      </div>
    </div>
  </div>
  <!--END Email Reports-->
  <!--Campaign Active-->
  <div class="element-container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="active"><?php echo _("Campaign Active") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="active"></i>
            </div>
            <div class="col-md-9 radioset">
              <input type="radio" name="active" id="activeyes" value="1" <?php echo ($active == "1"?"CHECKED":"") ?>>
              <label for="activeyes"><?php echo _("Yes");?></label>
              <input type="radio" name="active" id="activeno"  value = "0" <?php echo ($active == "1"?"":"CHECKED") ?>>
              <label for="activeno"><?php echo _("No");?></label>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="active-help" class="help-block fpbx-help-block"><?php echo _("Select Yes to activate campaign upon addition/modification.  Note, you still need to click the Start button on the Settings page to initiate the broadcast application ")?></span>
      </div>
    </div>
  </div>
  <!--END Campaign Active-->
  <!--Call Groups-->
  <div class="element-container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="cgwrapper"><?php echo _("Call Groups") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="cgwrapper"></i>
            </div>
            <div class="col-md-9">
              <select name="active_groups[]" id="active_groups" class="form-control" multiple="multiple">
								<?php echo $callgroupopts ?>
							</select>
						</div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="cgwrapper-help" class="help-block fpbx-help-block"><?php echo _("Groups to include in calls from this campaign.")?></span>
      </div>
    </div>
  </div>
  <!--END Call Groups-->
  <!--Schedule-->
  <div class="element-container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="schedulew"><?php echo _("Schedule") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="schedulew"></i>
            </div>
            <div class="col-md-9">
              <table>
                <tr>
                  <td><?php echo _("Start Time")?></td>
                  <td>
                    <div class="form-inline">
                    <select class="form-control" name="start_time_hour">
                      <?php echo hour_options($start_time_hour)?>
                    </select>
                    <select class="form-control" name="start_time_minute">
                      <?php echo minute_options($start_time_minute)?>
                    </select>
                    <select class="form-control" name="start_time_ampm">
                      <option value="AM"<?php echo ($start_time_ampm =="AM"?" selected":"")?>><?php echo _("AM")?></option>
                      <option value="PM"<?php echo ($start_time_ampm =="PM"?" selected":"")?>><?php echo _("PM")?></option>
                    </select>
                    </div>
                  </td>
                </tr>
                <tr>
                  <td><?php echo _("End Time")?></td>
                  <td>
                    <div class="form-inline">
                    <select class="form-control" name="end_time_hour">
                      <?php echo hour_options($end_time_hour)?>
                    </select>
                    <select class="form-control" name="end_time_minute">
                      <?php echo minute_options($end_time_minute)?>
                    </select>
                    <select class="form-control" name="end_time_ampm">
                      <option value="AM"<?php echo ($end_time_ampm =="AM"?" selected":"")?>><?php echo _("AM")?></option>
                      <option value="PM"<?php echo ($end_time_ampm =="PM"?" selected":"")?>><?php echo _("PM")?></option>
                    </select>
                    </div>
                  </td>
                </tr>
                <tr>
                  <td><?php echo _("Start Date")?></td>
                  <td>
                    <div class="form-inline">
                    <select class="form-control" name="start_date_month">
                      <?php echo month_options($start_date_month)?>
                    </select>
                    <select class="form-control" name="start_date_day">
                      <?php echo day_options($start_date_day)?>
                    </select>
                    <select  class="form-control" name="start_date_year">
                      <?php echo year_options($start_date_year)?>
                    </select>
                  </div>
                  </td>
                </tr>
                <tr>
                  <td><?php echo _("End Date")?></td>
                  <td>
                    <div class="form-inline">
                    <select class="form-control" name="end_date_month">
                      <?php echo month_options($end_date_month)?>
                    </select>
                    <select class="form-control" name="end_date_day">
                      <?php echo day_options($end_date_day)?>
                    </select>
                    <select class="form-control" name="end_date_year">
                      <?php echo year_options($end_date_year)?>
                    </select>
                  </div>
                  </td>
                </tr>
                <tr>
                  <td><?php echo _("Only Call Between")?></td>
                  <td>
                    <div class="form-inline">
                    <select class="form-control" name="start_week_day">
                      <option value=""><?php echo _("Optional")?></option>
                      <option value="1"<?php echo ($start_week_day == "1"?" selected":"")?>><?php echo _("Monday")?></option>
                      <option value="2"<?php echo ($start_week_day == "2"?" selected":"")?>><?php echo _("Tuesday")?></option>
                      <option value="3"<?php echo ($start_week_day == "3"?" selected":"")?>><?php echo _("Wednesday")?></option>
                      <option value="4"<?php echo ($start_week_day == "4"?" selected":"")?>><?php echo _("Thursday")?></option>
                      <option value="5"<?php echo ($start_week_day == "5"?" selected":"")?>><?php echo _("Friday")?></option>
                      <option value="6"<?php echo ($start_week_day == "6"?" selected":"")?>><?php echo _("Saturday")?></option>
                      <option value="7"<?php echo ($start_week_day == "7"?" selected":"")?>><?php echo _("Sunday")?></option>
                    </select>
                    <select class="form-control" name="end_week_day">
                      <option value=""><?php echo _("Optional")?></option>
                      <option value="1"<?php echo ($end_week_day == "1"?" selected":"")?>><?php echo _("Monday")?></option>
                      <option value="2"<?php echo ($end_week_day == "2"?" selected":"")?>><?php echo _("Tuesday")?></option>
                      <option value="3"<?php echo ($end_week_day == "3"?" selected":"")?>><?php echo _("Wednesday")?></option>
                      <option value="4"<?php echo ($end_week_day == "4"?" selected":"")?>><?php echo _("Thursday")?></option>
                      <option value="5"<?php echo ($end_week_day == "5"?" selected":"")?>><?php echo _("Friday")?></option>
                      <option value="6"<?php echo ($end_week_day == "6"?" selected":"")?>><?php echo _("Saturday")?></option>
                      <option value="7"<?php echo ($end_week_day == "7"?" selected":"")?>><?php echo _("Sunday")?></option>
                    </select>
                  </div>
                  </td>
                </tr>
              </table>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="schedulew-help" class="help-block fpbx-help-block"><?php echo _("Date/Time Options for this campaign")?></span>
      </div>
    </div>
  </div>
  <!--END Schedule-->
  <!--Destination - Live Person Answered-->
  <div class="element-container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="goto1"><?php echo _("Destination - Live Person Answered") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="goto1"></i>
            </div>
            <div class="col-md-9">
              <?php
              if (isset($destination_person)) {
                      echo drawselects($destination_person,1);
              } else {
                      echo drawselects(null, 1);
              }
              ?>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="goto1-help" class="help-block fpbx-help-block"><?php echo _("Where to send calls answered by a live person.")?></span>
      </div>
    </div>
  </div>
  <!--END Destination - Live Person Answered-->
  <!--Destination - Answering Machine / Voicemail Answered-->
  <div class="element-container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="form-group">
            <div class="col-md-3">
              <label class="control-label" for="goto2"><?php echo _("Destination - Answering Machine / Voicemail Answered") ?></label>
              <i class="fa fa-question-circle fpbx-help-icon" data-for="goto2"></i>
            </div>
            <div class="col-md-9">
              <?php
              //draw goto selects
              if (isset($destination_machine)) {
                      echo drawselects($destination_machine,2);
              } else {
                      echo drawselects(null, 2);
              }
              ?>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <span id="goto2-help" class="help-block fpbx-help-block"><?php echo _("Where to send Answering Machine calls")?></span>
      </div>
    </div>
  </div>
  <!--END Destination - Answering Machine / Voicemail Answered-->
</form>

<script type="text/javascript">
$( document ).ready(function() {
	$('#active_groups').multiselect({
			enableFiltering: true,
			includeSelectAllOption: true,
			enableCaseInsensitiveFiltering: true
	});
});

var theForm = document.editCampaign;

function editCampaign_onsubmit() {
  var items = $('#included').find("span");
	var msgInvalidNumber = "<?php echo _("Please enter a valid Number"); ?>";
	var msgInvalidName = "<?php echo _("Please enter a valid Name"); ?>";
	var msgInvalidCampaignName = "<?php echo _("Please enter a valid Campaign Name"); ?>";
	var msgInvalidGroups = "<?php echo _("Please select at least one call group."); ?>";
	var msgInvalidHuman = "<?php echo _("Please select a destination for Live Person Answered."); ?>";
	var msgInvalidMachine = "<?php echo _("Please select a destination for Answering Machine/Voicemail Answered."); ?>";
	defaultEmptyOK = false;


	if (!isAlphanumeric(theForm.campaignName.value))  {
		return warnInvalid(theForm.campaignName, msgInvalidCampaignName);
	}

	var atLeastOneChecked=false;
	 if($("select[name='active_groups[]'] :selected").length > 0)  {
			atLeastOneChecked = true;
	}

	if(!atLeastOneChecked)  {
		var f;
		if(theForm["active_groups[]"][0])  {
			f=theForm["active_groups[]"][0]
		}
		else  {
			f=theForm["active_groups[]"];
		}
		return warnInvalid(f,msgInvalidGroups);
	}
	atLeastOneChecked = false;
	for(var i=0; i < theForm["goto1"].length; i++)  {
		if(theForm["goto1"][i].selected) {
			atLeastOneChecked = true;
		}

	}
	if(!atLeastOneChecked)  {
		var f = theForm["goto1"][0];
		return warnInvalid(f,msgInvalidHuman);
	}
	atLeastOneChecked = false;
	for(var i=0; i < theForm["goto2"].length; i++)  {
		if(theForm["goto2"][i].selected) {
			atLeastOneChecked = true;
		}

	}
	if(!atLeastOneChecked)  {
		var f = theForm["goto2"][0];
		return warnInvalid(f,msgInvalidMachine);
	}


	defaultEmptyOK = true;

	return true;
}

  </script>
<?php
}
