<?php
include realpath(__DIR__ . '/..').'/enc/Service.class.php';
$s = new Service();
$service = `pgrep -f broadcast_service.php`;
?>
<div class="panel panel-default">
  <div class="panel-heading"><h2><?php echo _("Important Notice")?></h2></div>
  <div class="panel-body">
    <?php echo _("The Broadcast service NO LONGER STOPS AUTOMATICALLY after completing a campaign.
    It will keep running and checking for newly active campaigns, or added numbers to call. This is a significant change
    from previous usage, and it's important you are aware of this.")?>
  </div>
  <div class="panel panel-default">
  <div class="panel-heading"><?php echo _("Service Status")?></div>
  <div class="panel-body">
    <?php echo _("Service is currently:")?> <b><?php echo ($service)?_("Running"):_("Stopped")?></b><br/>
    <?php
    	if ($service) {
    		// Stop
    		$btn = "<input type='button' name='stop' value='Stop' onClick='ajaxBroadcast(\"Stop\",false)'>";
    	} else {
    		$btn = "<input type='button' name='start' value='Start' onClick='ajaxBroadcast(\"Start\",false)'>";
    	}
    	echo $btn;
    ?>
  </div>
</div>
</div>
<?php
$campaigns = $s->getAllCampaigns();
if ($campaigns['current']) {
  print "<h2>"._("Current Campaigns")."</h2>";
  print '<table class="table table-striped">';
  print "<tr> <th>Active</th> <th>"._("Name")."</th> <th colspan=2>"._("Start Time")."</th> <th>"._("Calls")."</th> <th>"._("Remaining")."</th> </tr>";
  foreach ($campaigns['current'] as $c) {
    print "<tr>";
    if ($s->isCampaignActive($c['id'])) {
      print "<td align='center'><input type='checkbox' name='active_campaigns[]' value='".$c['id']."' checked data-id='".$c['id']."'></td>";
    } else {
      print "<td align='center'><input type='checkbox' name='active_campaigns[]' value='".$c['id']."' data-id='".$c['id']."'></td>";
    }

    print '<td>'.$c['name'].'</td>';
    print '<td colspan=2>'.$s->getTimeStamp($c['runid']).' </td>';
    print '<td>'.$c['callsmade'].'</td>';
    print '<td>'.$c['callsremaining'].'</td>';

    // Buttons! Buttonsbuttonsbuttonsbuttons!
    print "<td><a href='?display=broadcast&campaign=".$c['id']."&action=report' class='btn btn-default'>"._("Report")."</a> &nbsp; ";
    print "<a href='?display=broadcast&campaign=".$c['id']."&action=abort' class='btn btn-default'>"._("Complete")."</a>";
    print "</tr>";
  }
  print '</table>';
}
if ($campaigns['complete']) {
  print "<h2>"._("Complete Campaigns")."</h2>";
  print '<table class="table table-striped">';
  print "<tr> <th colspan=2>"._("Campaign Name")."</th> <th colspan=2>"._("Start Time")."</th> <th>"._("Calls")."</th> <th>"._("Remaining")."</th> </tr>";
  foreach ($campaigns['complete'] as $c) {
    print '<tr><td colspan=2>'.$c['name'].'</td>';
    print '<td colspan=2>'.$s->getTimeStamp($c['runid']).' </td>';
    print '<td>'.$c['callsmade'].'</td>';
    print '<td>'.$c['callsremaining'].'</td>';

    // Buttons! Buttonsbuttonsbuttonsbuttons!
    print "<td><a href='?display=broadcast&campaign=".$c['id']."&action=report' class='btn btn-default'>"._("Report")."</a> &nbsp; ";
    print "<a href='?display=broadcast&campaign=".$c['id']."&action=restart' class='btn btn-default'>"._("Restart")."</a>";
    print "</tr>";
  }
  print '</table>';
}
if ($campaigns['history']) {
  print "<h2>"._("Previous Campaigns")."</h2>";
  print '<table class="table table-striped">';
  print "<tr><th colspan=2>"._("Campaign Name")."</th> <th colspan=2>"._("Start Time")."</th> <th>"._("Calls")."</th></tr>";
  foreach ($campaigns['history'] as $c) {
    print '<tr><td colspan=2>'.$c['name'].'</td>';
    print '<td colspan=2>'.$s->getTimeStamp($c['runid']).' </td>';
    print '<td>'.$c['callsmade'].'</td>';

    // MOAR BUTTONS!
    $target="action='?display=broadcast&campaign=".$c['runid'];
    if ($c['runid'] == 'NULL') {
      $disabled = "disabled";
    } else {
      $disabled = "";
    }
    print "<td></td><td><button type='ajax' $target&action=report' >"._("Report")."</button> &nbsp; ";
    print "<button type='ajax' $target&action=delcamp' >"._("Delete")."</button> &nbsp; ";
    print "</tr>";
  }
  print "</table>";
}
?>
<script type="text/javascript">
  $(document).ready(function(){
    $('input[name^="active_campaigns"]').change(function(){
      var id = $(this).data('id');
      var state = ($(this).is(':checked'))?'yes':'no';
      $.get( "ajax.php?module=broadcast&command=campaignSwitch&id="+id+"&state="+state, function() {
        fpbxToast(_("Campaign Updated"));
      });
    });

  });
</script>
