<?php
namespace FreePBX\modules;

class Calllimit implements \BMO {
	public function __construct($freepbx = null) {
		if ($freepbx == null) {
			throw new Exception("Not given a FreePBX Object");
		}
		$this->FreePBX = $freepbx;
		$this->db = $freepbx->Database;
	}
	public function install() {}
	public function uninstall() {}
	public function backup() {}
	public function restore($backup) {}
	public function doConfigPageInit($page) {
    $action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
    $itemid = (isset($_REQUEST['itemid']))?$_REQUEST['itemid']:'';
    switch($action){
      case 'add':
          calllimit_put($_POST);
          needreload();
          break;
      case 'delete':
          calllimit_del($itemid);
          needreload();
          break;
      case 'edit':
          calllimit_put($_POST);
          needreload();
          break;
      default:
          break;
    }
  }
	public function getActionBar($request) {
		$buttons = array();
		switch($request['display']) {
			case 'calllimit':
				$buttons = array(
					'delete' => array(
						'name' => 'delete',
						'id' => 'delete',
						'value' => _('Delete')
					),
					'reset' => array(
						'name' => 'reset',
						'id' => 'reset',
						'value' => _('Reset')
					),
					'submit' => array(
						'name' => 'submit',
						'id' => 'submit',
						'value' => _('Submit')
					)
				);
				if (empty($request['itemid'])) {
					unset($buttons['delete']);
				}
        if(!isset($_REQUEST['view'])){
          $buttons = array();
        }
			break;
		}
		return $buttons;
	}
	public function ajaxRequest($req, &$setting) {
		switch ($req) {
			case 'getJSON':
				return true;
			break;
			default:
				return false;
			break;
		}
	}
	public function ajaxHandler(){
		switch ($_REQUEST['command']) {
			case 'getJSON':
				switch ($_REQUEST['jdata']) {
					case 'grid':
						return array_values($this->getAll());
					break;
					default:
						return false;
					break;
				}
			break;
			default:
				return false;
			break;
		}
	}
  public function getAll(){
    $dbh = $this->db;
    $sql = 'SELECT DISTINCT(`value`) from calllimit where `key` like "%\_id" ORDER BY `value`';
    $stmt = $dbh->prepare($sql);
    $stmt->execute();
    $res = $stmt->fetchAll();
		$retarr = array();
		foreach ($res as $id) {
  		$retarr[$id[0]] = $this->getOne($id[0]);
  	}
  	return $retarr;
  }
  public function getOne($id = 1){
    $dbh = \FreePBX::Database();
    $stmt = $dbh->prepare('SELECT value FROM calllimit WHERE `key` = ?');
    // All the keys we want to get.
    $values = array( "id", "name", "recording", "recordingid", "periodtype_1", "periodtype_2", "periodtype_3",
      "periodlength_1", "periodlength_2","periodlength_3", "qty_1", "qty_2", "qty_3");

    // Go through all the keys, build array!
    foreach ($values as $key) {
      $item = $id."_".$key;
      $res = $stmt->execute(array($item));
      $row = $stmt->fetchColumn();
      $results[$key]=$row;
    }

    if (!is_array($results)) {
      $results = array();
    }

    return $results;
  }

}
