<?php
if ($itemid) {
	$calllimit = calllimit_get($itemid);
	extract($calllimit,EXTR_SKIP);
	$usage_list = framework_display_destination_usage(calllimit_getdest($itemid));
	$usehtml = '';
  if (!empty($usage_list)) {
		$usehtml .= '<div class="alert alert-info">';
		$usehtml .= '<b>'.$usage_list['text'].'</b><br/>';
		$usehtml .= $usage_list['tooltip'];
		$usehtml .= '</div>';
	}
  $subhead = "<h2>"._("Edit: ").$calllimit['name']."</h2>";
	$delURL = '?display=calllimit&action=delete&itemid='.$itemid;
} else {
	$subhead = "<h2>"._("Add Outbound Call Limit")."</h2>";
	$usehtml = '';
	$delURL = '';
}
echo $subhead;
echo $usehtml;
?>
<form name="editCalllimit" action="" method="POST" class="fpbx-submit" data-fpbx-delete="<?php echo $delURL?>">
	<input type="hidden" name="itemid" value="<?php echo $itemid; ?>">
	<input type="hidden" name="id" value="<?php echo $itemid; ?>">
	<input type="hidden" name="action" value="<?php echo ($itemid ? 'edit' : 'add'); ?>">
	<!--Name-->
	<div class="element-container">
		<div class="row">
			<div class="col-md-12">
				<div class="row">
					<div class="form-group">
						<div class="col-md-3">
							<label class="control-label" for="name"><?php echo _("Name") ?></label>
							<i class="fa fa-question-circle fpbx-help-icon" data-for="name"></i>
						</div>
						<div class="col-md-9">
							<input type="text" class="form-control" id="name" name="name" value="<?php echo isset($name)?$name:''?>">
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="row">
			<div class="col-md-12">
				<span id="name-help" class="help-block fpbx-help-block"><?php echo _("Enter the name of your outbound call limit rule to make it easier to select in your outbound route.")?></span>
			</div>
		</div>
	</div>
	<!--END Name-->
	<br/>
	<br/>
	<div class="alert alert-info">
		<p><?php echo _("Select the maximum number of calls that can be made in a single period.")?></p>
		<p><?php echo _("Note that this will match against <strong>all fields</strong>.")?></p>
		<p><?php echo _("This means, for example, if you have a maximum of '10' in a 5 hour period, but a maximum of '5' per day, it will block calls after 5, because it will match on the 'per day' field.")?></p>
	</div>
	<?php
			foreach (array(1,2,3) as $query) {
					$qty = isset($calllimit['qty_'.$query])?$calllimit['qty_'.$query]:'1';
					$len = isset($calllimit['periodlength_'.$query])?$calllimit['periodlength_'.$query]:'1';
					echo '<table>';
					echo '<tr><td>';
					echo '<h3>'._("A Maximum of").'</h3>';
					echo '</td><td>';
					echo "<input class='form-control' type='number' name='qty_$query' value='$qty' /> ";
					echo '</td><td>';
					echo '<h3>'._("calls per").'</h3>';
					echo '</td><td>';
					echo "<input class='form-control' type='number' name='periodlength_$query' value='$len' />";
					echo '</td><td>';
					echo '<select class="form-control" name="periodtype_'.$query."\">";
					$translationstrings = array(_('Unused'), _('Hours'), _('Days'), _('Months'));
					foreach (array('Unused', 'Hours', 'Days', 'Months') as $period) {
							$thisperiodtype = isset($calllimit['periodtype_'.$query])?$calllimit['periodtype_'.$query]:'Unused';
							echo '<option value="'.$period.'" '.($period == $thisperiodtype ? ' SELECTED' : '').'>'._($period)."</option>\n";
					}
					echo "</select>\n";
					echo '</td></tr/></table>';
					if ($query != 3){

						echo "<br/><h3>"._('or')."</h3></br>";
					}
			}
      echo '<br/>';
			if (function_exists('recordings_list')) { ?>
				<!--Recording-->
				<div class="element-container">
					<div class="row">
						<div class="col-md-12">
							<div class="row">
								<div class="form-group">
									<div class="col-md-3">
										<label class="control-label" for="recording"><?php echo _("Limit Reached Message") ?></label>
										<i class="fa fa-question-circle fpbx-help-icon" data-for="recording"></i>
									</div>
									<div class="col-md-9">
										<select class="form-control" id="recording" name="recording">
											<?php
													$tresults = recordings_list();
													$default = (isset($calllimit['recording_id']) ? $calllimit['recording_id']: '');
													echo '<option value="None">'._("Default");
													if (isset($tresults[0])) {
															foreach ($tresults as $tresult) {
																	echo '<option value="'.$tresult['id'].'"'.($tresult['id'] == $default ? ' SELECTED' : '').'>'.$tresult['displayname']."</option>\n";
															}
													}
											?>
										</select>
									</div>
								</div>
							</div>
						</div>
					</div>
					<div class="row">
						<div class="col-md-12">
							<span id="recording-help" class="help-block fpbx-help-block"><?php echo _("Select the recording to be played to the caller when they have hit this limit and are unable to complete their outbound call.")?></span>
						</div>
					</div>
				</div>
				<!--END Recording-->
				<?php } else { ?>
					<div class="alert alert-warning">
						<?php echo _("The recordings module seems to be disabled or not installed. The default message will be played to callers when their call limit is reached")?>
					</div>
					<?php }
							//add hooks
              if(isset($module_hook)){
							  echo $module_hook->hookHtml;
              }
					?>
				</form>
