<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="conferenceenable"><?php echo _("Enable Conference Access") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="conferenceenable"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="conference_enable" id="conference_enable_yes" value="yes" <?php echo ($enable) ? 'checked' : ''?>>
						<label for="conference_enable_yes"><?php echo _("Yes")?></label>
						<input type="radio" name="conference_enable" id="conference_enable_no" value="no" <?php echo (!is_null($enable) && !$enable) ? 'checked' : ''?>>
						<label for="conference_enable_no"><?php echo _("No")?></label>
						<?php if($mode == "user") {?>
							<input type="radio" id="conference_enable_inherit" name="conference_enable" value='inherit' <?php echo is_null($enable) ? 'checked' : ''?>>
							<label for="conference_enable_inherit"><?php echo _('Inherit')?></label>
						<?php } ?>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="conferenceenable-help" class="help-block fpbx-help-block"><?php echo _("Enable the conference Access in UCP for this user")?></span>
		</div>
	</div>
</div>
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="ucp_conferences"><?php echo _("Allowed Conference Bridges")?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="ucp_conferences"></i>
					</div>
					<div class="col-md-9">
						<select id="ucp_conferences" class="form-control chosenmultiselect ucp-conference" name="ucp_conferences[]" multiple="multiple" data-placeholder="<?php echo _('Conferences')?>" <?php echo (!is_null($enable) && !$enable) ? "disabled" : ""?>>
							<?php foreach($conferences as $conference) {?>
								<option value="<?php echo $conference[0]?>" <?php echo in_array($conference[0],$selected) ? 'selected' : '' ?>><?php echo $conference[1]?> &lt;<?php echo $conference[0]?>&gt;</option>
							<?php } ?>
						</select>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="ucp_conferences-help" class="help-block fpbx-help-block"><?php echo _("These are the assigned and active extensions which will show up for this user to control and edit in UCP")?></span>
		</div>
	</div>
</div>
<script>
	$("input[name=conference_enable]").change(function() {
		if($(this).val() == "yes" || $(this).val() == "inherit") {
			$(".ucp-conference").prop("disabled",false).trigger("chosen:updated");;
		} else {
			$(".ucp-conference").prop("disabled",true).trigger("chosen:updated");;
		}
	});
</script>
