<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
require_once(dirname(__FILE__) . '/functions.inc.php');
global $db, $amp_conf;
set_time_limit(0);
include_once("functions.inc/functions_general.php");

$new = $db->query('SELECT `key` FROM endpoint_global');
if ($db->IsError($new)) {
	$newInstall = true;
} else {
	$newInstall = false;

	//check if we need to migrate XML to XML-API
	$q = "SELECT * FROM endpoint_global where `key` = 'legacyXML'";
	$r = $db->getAll($q, DB_FETCHMODE_ASSOC);
	if(!empty($r)){
		foreach($r as $key){
			if(!empty($key['key']) && $key['key'] == 'legacyXML'){
				if($key['values'] != 'Y'){
					include("migrateXML.php");
				}
			} else {
				include("migrateXML.php");
			}
		}
	} else {
		include("migrateXML.php");
	}

	$test = $db->query('SELECT * FROM endpoint_timezones');
	if ($db->IsError($test)) {
	} else {
			$sql[] = "DROP TABLE `endpoint_timezones`";
	}
	$test = $db->query('SELECT * FROM endpoint_brand');
	if ($db->IsError($test)) {
	} else {
			$sql[] = "DROP TABLE `endpoint_brand`";
	}
	$test = $db->query('SELECT * FROM endpoint_models');
	if ($db->IsError($test)) {
	} else {
			$sql[] = "DROP TABLE `endpoint_models`";
	}
	$test = $db->query('SELECT * FROM endpoint_xml');
	if ($db->IsError($test)) {
	} else {
			$sql[] = "DROP TABLE `endpoint_xml`";
	}
	$test = $db->query('SELECT * FROM endpoint_brands');
	if ($db->IsError($test)) {
	} else {
			$sql[] = "DROP TABLE `endpoint_brands`";
	}
	$test = $db->query('SELECT * FROM endpoint_aastra_extra');
	if ($db->IsError($test)) {
	} else {
			$sql[] = "DROP TABLE `endpoint_aastra_extra`";
	}
	$test = $db->query('SELECT `daylight` FROM endpoint_templates');
	if ($db->IsError($test)) {
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `daylight` VARCHAR(2)";
	}
	$test = $db->query('SELECT `models` FROM endpoint_templates');
	if ($db->IsError($test)) {
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `models` VARCHAR(200)";
	}

	$sql[] = "ALTER TABLE endpoint_basefiles MODIFY COLUMN `param` VARCHAR(120)";
	$sql[] = "ALTER TABLE endpoint_basefiles MODIFY COLUMN `model` VARCHAR(512)";

	$test = $db->query('SELECT `rebuild` FROM endpoint_extensions');
	if ($db->IsError($test)) {
		$sql[] = "ALTER TABLE endpoint_extensions ADD COLUMN `rebuild` VARCHAR(20)";
	}
	$test = $db->query('SELECT `dialpattern` FROM endpoint_templates');
	if ($db->IsError($test)) {
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `dialpattern` VARCHAR(512)";
	}

	//fix for polycom to eliminate info=
    $test = $db->query('SELECT `setting` FROM paging_autoanswer WHERE `useragent` = \'Polycom\'');
    if ($db->IsError($test)) {
        //do nothing
    } else {
        $sql[] = "update paging_autoanswer set `setting` = 'Alert-Info: Auto Answer' where `useragent` = 'Polycom'";
    }

    $test = $db->query('SELECT * FROM endpoint_basefiles');
    if($db->IsError($test)){
    	//do nothing
    } else {
    	$sql[] = "DELETE FROM endpoint_basefiles WHERE `template` = 'default'";
    }

	$test = $db->query('SELECT wEnable1 FROM endpoint_templates');
    if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `wEnable1` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `wssid1` VARCHAR(64)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `wsecurity1` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `wWEPBits1` VARCHAR(5)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `wWPAPSKPass1` VARCHAR(64)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `wWPAPSKKey1` VARCHAR(64)";
	}
	$test = $db->query('SELECT hotline FROM endpoint_templates');
    if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `hotline` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `hotlineDest` VARCHAR(254)";
	}
	$test = $db->query('SELECT accessory FROM endpoint_extensions');
    if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_extensions MODIFY COLUMN `accessory` VARCHAR(100)";
	}

	$test = $db->query('SELECT exp4 FROM endpoint_extensions');
    if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_extensions ADD COLUMN `exp3` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_extensions ADD COLUMN `exp4` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_extensions ADD COLUMN `exp5` VARCHAR(20)";
	}

	$test = $db->query('SELECT vpn FROM endpoint_extensions');
    if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_extensions ADD COLUMN `vpn` int(11)";
	}

	$test = $db->query('SELECT repeater1 FROM endpoint_extensions');
    if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_extensions ADD COLUMN `repeater1` VARCHAR(255)";
		$sql[] = "ALTER TABLE endpoint_extensions ADD COLUMN `repeater2` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_extensions ADD COLUMN `repeater3` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_extensions ADD COLUMN `multicell` VARCHAR(255)";
	}
	
	//add backup dest and port
	$test = $db->query('SELECT backupDest FROM endpoint_templates');
    if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `backupDest` VARCHAR(40)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `backupPort` VARCHAR(10)";
	}

	//add outbound proxy and backup
	$test = $db->query('SELECT outboundProxy FROM endpoint_templates');
    if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `outboundProxy` VARCHAR(40)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `outboundProxyPort` VARCHAR(10)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `backupOutboundProxy` VARCHAR(40)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `backupOutboundProxyPort` VARCHAR(10)";
	}
	
	//country selection for Sangoma phones
	$test = $db->query('SELECT country FROM endpoint_templates');
	if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `country` VARCHAR(3)";
	}

	//backlight selection for Sangoma phones
	$test = $db->query('SELECT backlightTimeout FROM endpoint_templates');
		if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `backlightTimeout` VARCHAR(4)";
	}

	//backlight settings selection for Sangoma phones
	$test = $db->query('SELECT backlightActive FROM endpoint_templates');
	if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `backlightActive` VARCHAR(4)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `backlightInActive` VARCHAR(4)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `labelScroll` VARCHAR(4)";
	}
	//headset settings selection for Sangoma phones
	$test = $db->query('SELECT headset FROM endpoint_templates');
	if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `headset` VARCHAR(4)";
	}

	//add new default option for int/ext
	$test = $db->query('SELECT internalDefault FROM endpoint_templates');
	if($db->IsError($test)){
		$sql2[] = "ALTER TABLE endpoint_templates ADD COLUMN `internalDefault` VARCHAR(3)";
		$sql2[] = "ALTER TABLE endpoint_templates ADD COLUMN `externalDefault` VARCHAR(3)";

		//migrate old
		$sql2[] = "UPDATE endpoint_templates SET `internalDefault` = '1', `externalDefault` = '1' WHERE `default` = '1'";
		foreach ($sql2 as $q) {
			$result = $db->query($q);
			if($db->IsError($result)){
					die_freepbx($result->getDebugInfo());
			}
		}
		unset($sql2);
	}

	//VLAN settings selection for Sangoma phones
	$test = $db->query('SELECT lldp FROM endpoint_templates');
	if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `lldp` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `lldpPacket` VARCHAR(5)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `vVlan` VARCHAR(5)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `vVlanP` VARCHAR(5)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `dVlan` VARCHAR(5)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `dhcpVlan` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `vlanMode` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `vlanIdentity` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `vlanPass` VARCHAR(64)";
	}

	//LDAP settings selection for Sangoma phones
	$test = $db->query('SELECT language FROM endpoint_templates');
	if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapNameFilter` VARCHAR(40)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapNumberFilter` VARCHAR(40)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapServerAddress` VARCHAR(40)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapPort` VARCHAR(40)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapBase` VARCHAR(80)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapUsername` VARCHAR(40)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapPassword` VARCHAR(40)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapMaxHits` VARCHAR(4)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapDisplayName` VARCHAR(40)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapSearchDelay` VARCHAR(4)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `lldpProtocol` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapLookupCall` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ldapSort` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `language` VARCHAR(2)";
	}

	$test = $db->query('SELECT entryTimeout FROM endpoint_templates');
	if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `entryTimeout` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `dialFirstDigit` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `shortPressIdleState` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `shortPressInUseState` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `longPressIdleState` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `longPressInUseState` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `longPressRingState` VARCHAR(20)";
	}

	$test = $db->query('SELECT logoled FROM endpoint_templates');
	if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `logoled` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `voicemailkey` VARCHAR(2)";
	}

	$test = $db->query('SELECT keypressTone FROM endpoint_templates');
	if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `keypressTone` VARCHAR(2)";
	}

	$test = $db->query('SELECT acr FROM endpoint_templates');
	if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `acr` VARCHAR(2)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `powerStatus` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `ringingStatus` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `misscallsStatus` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `voicemessageStatus` VARCHAR(20)";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `activecallStatus` VARCHAR(20)";
		$sql[] = "UPDATE endpoint_extensions SET `vpn` = null WHERE `vpn` = '0'";
	}
	$test = $db->query('SELECT confCallRelease FROM endpoint_templates');
	if($db->IsError($test)){
		$sql[] = "ALTER TABLE endpoint_extensions MODIFY COLUMN `vpn` VARCHAR(11) default null";
		$sql[] = "ALTER TABLE endpoint_templates ADD COLUMN `confCallRelease` VARCHAR(2)";
	}

	//change to varchar to allow leading 0's
	$sql[] = "ALTER TABLE endpoint_extensions MODIFY COLUMN `ext` VARCHAR(20)";

    foreach ($sql as $q) {
        $result = $db->query($q);
        if($db->IsError($result)){
            die_freepbx($result->getDebugInfo());
        }
    }
    unset($sql);
}

//create new common tables
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_buttons` (`id` INT(20) NOT NULL AUTO_INCREMENT, `brand` VARCHAR(20), `template_name` VARCHAR(45), `key` VARCHAR(60), `value` VARCHAR(120), `daylight` VARCHAR(2), UNIQUE KEY `id` (`id`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_ext_buttons` (`id` INT(20) NOT NULL AUTO_INCREMENT, `ext` VARCHAR(20), `brand` VARCHAR(20), `template_name` VARCHAR(45), `key` VARCHAR(60), `value` VARCHAR(120), UNIQUE KEY `id` (`id`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_templates` (`id` INT(20) NOT NULL AUTO_INCREMENT, `brand` VARCHAR(20), `default` VARCHAR(2), `template_name` VARCHAR(45), `destination` VARCHAR(40), `focus` VARCHAR(1), `answer` VARCHAR(1), `mute` VARCHAR(1), `barge` VARCHAR(1), `offhook` VARCHAR(1), `stutter` VARCHAR(1), `timeout` VARCHAR(2), `toneset` VARCHAR(12), `time_server` VARCHAR(1), `time_server_1` VARCHAR(30), `time_server_2` VARCHAR(30),`time_server_3` VARCHAR(30), `timezone` VARCHAR(30), `protocol` VARCHAR(10), `ftpuser` VARCHAR(40), `ftppass` VARCHAR(40), `ftpserver` VARCHAR(40), `extra` VARCHAR(400), `ext` VARCHAR(80), `missed` VARCHAR(1), `volume` VARCHAR(1), `echo` VARCHAR(1),  `callwaiting` VARCHAR(2), `features` VARCHAR(1024), `background` VARCHAR(256), `outgoing` VARCHAR(256), `firmware` VARCHAR(1) default '0', `multicastAddress` VARCHAR(1024), `multicastEnable` VARCHAR(2), `lineLabel` VARCHAR(2), `daylight` VARCHAR(2), `dialpattern` VARCHAR(512), `models` VARCHAR(200) default '0', `backupDest` VARCHAR(40), `backupPort` VARCHAR(10), `outboundProxy` VARCHAR(40), `outboundProxyPort` VARCHAR(10), `backupOutboundProxy` VARCHAR(40), `backupOutboundProxyPort` VARCHAR(10), `country` VARCHAR(3), `wEnable1` VARCHAR(2), `wssid1` VARCHAR(64), `wsecurity1` VARCHAR(2), `wWEPBits1` VARCHAR(5), `wWPAPSKPass1` VARCHAR(64), `wWPAPSKKey1` VARCHAR(64), `hotline` VARCHAR(2), `hotlineDest` VARCHAR(254), `internalDefault` VARCHAR(3), `externalDefault` VARCHAR(3), `backlightActive` VARCHAR(4), `backlightInActive` VARCHAR(4), `labelScroll` VARCHAR(4), `headset` VARCHAR(4), `lldp` VARCHAR(2), `lldpPacket` VARCHAR(5), `vVlan` VARCHAR(5), `vVlanP` VARCHAR(5), `dVlan` VARCHAR(5), `dhcpVlan` VARCHAR(2), `vlanMode` VARCHAR(2), `vlanIdentity` VARCHAR(20), `vlanPass` VARCHAR(64), `ldapNameFilter` VARCHAR(40), `ldapNumberFilter` VARCHAR(40), `ldapServerAddress` VARCHAR(40), `ldapPort` VARCHAR(40), `ldapBase` VARCHAR(80), `ldapUsername` VARCHAR(40), `ldapPassword` VARCHAR(40), `ldapMaxHits` VARCHAR(4), `ldapDisplayName` VARCHAR(40), `ldapSearchDelay` VARCHAR(4), `lldpProtocol` VARCHAR(2), `ldapLookupCall` VARCHAR(2), `ldapSort` VARCHAR(2), `language` VARCHAR(2), `entryTimeout` VARCHAR(2), `dialFirstDigit` VARCHAR(2), `shortPressIdleState` VARCHAR(20), `shortPressInUseState` VARCHAR(20), `longPressIdleState` VARCHAR(20), `longPressInUseState` VARCHAR(20), `longPressRingState` VARCHAR(20), `logoled` VARCHAR(2), `voicemailkey` VARCHAR(2), `keypressTone` VARCHAR(2), `acr` VARCHAR(2), UNIQUE KEY `id` (`id`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_global` (`key` VARCHAR(25), `values` VARCHAR(2048), UNIQUE KEY `key` (`key`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_extensions` (`ext` VARCHAR(20), `brand` VARCHAR(20), `mac` VARCHAR(20), `template` VARCHAR(45), `model` VARCHAR(25), `account` VARCHAR(12), `accessory` VARCHAR(100), `exp0` VARCHAR(20), `exp1` VARCHAR(20), `exp2` VARCHAR(20), `exp3` VARCHAR(20), `exp4` VARCHAR(20), `exp5` VARCHAR(20), `blf` VARCHAR(20), `blf_label` VARCHAR(20), `rebuild` VARCHAR(20), `repeater1` VARCHAR(255), `repeater2` VARCHAR(20), `repeater3` VARCHAR(20), `multicell` VARCHAR(255), `country` VARCHAR(3), `vpn` int(11) default null, UNIQUE KEY `ext` (`ext`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_models` (`brand` VARCHAR(20), `type` VARCHAR(10), `model` VARCHAR(25), `accounts` VARCHAR(3), `prgkey` VARCHAR(3), `softkeys` VARCHAR(3), `topsoftkey` VARCHAR(3), `extrakey` VARCHAR(3), `linekeys` VARCHAR(3), `horsoftkeys` VARCHAR(3), `speeddial` VARCHAR(3), `global` VARCHAR(1024), `firmware` VARCHAR(256), `exp` VARCHAR(3), UNIQUE KEY `model` (`model`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_basefiles` (`id` int(11) NOT NULL auto_increment, `brand` varchar(20) default NULL, `template` varchar(45), `model` varchar(512) default NULL, `type` varchar(20) default NULL, `file` VARCHAR(40), `define` varchar(80) default NULL, `param` varchar(120) default NULL, `attrib` varchar(60) default NULL, `value` varchar(254) default NULL, `edited` varchar(1), `description` varchar(160), `OID` VARCHAR(10), PRIMARY KEY  (`id`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_xml` (`api` VARCHAR(1), `app_name` VARCHAR(80), `url` VARCHAR(256), `9112i` VARCHAR(1), `6731i` VARCHAR(1), `6739i` VARCHAR(1), `9133i` VARCHAR(1), `9143i` VARCHAR(1), `480i` VARCHAR(1), `9480i` VARCHAR(1), `9480iCT` VARCHAR(1), `53i` VARCHAR(1), `55i` VARCHAR(1), `57i` VARCHAR(1), `6735i` VARCHAR(1), `6737i` VARCHAR(1), `51i` VARCHAR(1), `57iCT` VARCHAR(1), `675-1` VARCHAR(1), `675-2` VARCHAR(1), `675-3` VARCHAR(1), UNIQUE KEY `app_name` (`app_name`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_images` (`key` VARCHAR(40), UNIQUE KEY `key` (`key`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_firmware` (`brand` VARCHAR(20), `slot1` VARCHAR(20), `slot2` VARCHAR(20), `installed1` VARCHAR(1), `installed2` VARCHAR(1), UNIQUE KEY `brand` (`brand`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_brand` (`id` INT(20) NOT NULL AUTO_INCREMENT, `brand` VARCHAR(20), `oui` VARCHAR(20), `basefile` VARCHAR(1024), `dialpattern` VARCHAR(512), UNIQUE KEY `id` (`id`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_customExt` (`id` INT(20) NOT NULL AUTO_INCREMENT, `ext` VARCHAR(20), `secret` VARCHAR(60), `label` VARCHAR(20), `destination` VARCHAR(60), `sipPort` VARCHAR(20), UNIQUE KEY `id` (`id`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_ignoreMac` (`id` INT(20) NOT NULL AUTO_INCREMENT, `mac` VARCHAR(20), UNIQUE KEY `id` (`id`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";
$sql[] = "CREATE TABLE IF NOT EXISTS `endpoint_timezones` (
	`id` int(11) NOT NULL auto_increment,
	`location` varchar(255) default NULL,
	`htek` varchar(255) default NULL,
	`ciscoFxs` varchar(10) default NULL,
	`vtech` varchar(255) default NULL,
	`mbu` varchar(3) default NULL,
	`cortelco` varchar(3) default NULL,
	`mocet` varchar(3) default NULL,
	`and` varchar(35) default NULL,
	`panasonic` varchar(5) default NULL,
	`panasonic2` varchar(10) default NULL,
	`cisco` varchar(255) default NULL,
	`ciscoEnt` varchar(255) default NULL,
	`obihai` varchar(255) default NULL,
	`aastra` VARCHAR(30),
	`code` varchar(255) default NULL,
	`offset` varchar(8) default NULL,
	`snomv8` varchar(10) default NULL,
	`snom` varchar(3) default NULL,
	`grandstream` varchar(40) default NULL,
	`yealink` varchar(40) default NULL,
	`digium` varchar(40) default NULL,
	`dp715` varchar(40) default NULL,
	`incom` varchar(5) default NULL,
	`phoenix` varchar(60) default NULL,
	PRIMARY KEY  (`id`)) AUTO_INCREMENT=168 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci";

//fill tables
//												id	location						htek			ciscoFxs			vtech																MBU			cort				mocet   	and                     panasonic   	pan2        		cisco   	cisco-Enterprise                        obihai                      aastra              code    offset           snomv8     snom-m9 grandstream                                             yealink                                 digium                              dp715       Incom			Phoenix
$sql[] = "INSERT INTO `endpoint_timezones` 
												(`id`, `location`, 			`htek`,			`ciscoFxs`,		`vtech`, 														`mbu`, `cortelco`,	`mocet`,	`and`, 									`panasonic`, 	`panasonic2`, 	`cisco`, 	`ciscoEnt`, 														`obihai`, 									`aastra`, 					`code`, `offset`, 			`snomv8`, 	`snom`, `grandstream`, 																					`yealink`, 															`digium`, 													`dp715`, 		`incom`,	`phoenix`)  VALUES
												('7', '-06:00',   				'14',			'-06 2 1',		'America/Chicago',                  '6', 		'9',				'12',   	'America/Chicago',      '-360',     	'-60003',   		'-6',   	'Central Standard/Daylight Time',       '(Central Time)',           'US-Central',       'CST',  '-21600',      	'USA-6',   	'310',  'CST6CDT',                                              'United States-Central Time',           'America/Chicago',                  'TZE+6',    '44', 		'Central Time (US & Canada)'),
												('1', '-12:00',   				'',				'',						'',                                 '0',		'0',				'0',    	'Etc/GMT-12',           '-720',     	'-',        		'',     	'Dateline Standard Time',               '(Int\'l Dateline West)',   '',                 '',     '',           	'',        	'',     '',                                                     '',                                     '',                                 'TZA+12',   '', 			'Dateline'),
												('2', '-11:00',   				'105',		'-11 1 0',		'Pacific/Pago_Pago',                '1',		'1',				'2',    	'Etc/GMT-11',           '-660',     	'-110001',  		'-11',  	'Samoa Standard Time',                  '(Samoa)',                  'AU-Perth',         'WST',  '-39600',    		'',        	'310',  'NZST-12NZDT-13,M10.1.0/02:00:00,M3.3.0/03:00:00',      'Samoa',                                'Pacific/Midway',                   'TZB+11',   '', 			'Samoa'),
												('3', '-10:00',   				'1',			'-10 1 0',		'Pacific/Honolulu',                 '2',		'2',    		'4',    	'Etc/GMT-10',           '-600',     	'-100001',  		'-10',  	'Hawaiian Standard Time',               '(Hawaii)',                 'US-Hawaii',        'HST',  '-36000',     	'USA-10',  	'310',  'HAW10',                                                'United States-Alaska-Aleutian',        'Pacific/Johnston',                 'TZC+10',   '36', 		'Hawaii'),
												('4', '-09:00',   				'3',			'-09 1 1',		'America/Anchorage',                '3',		'3',    		'6',    	'Etc/GMT-9',            '-540',     	'-90002',   		'-9',   	'Alaskan Standard/Daylight Time',       '(Alaska)',                 'US-Alaska',        'AKS',  '-32400',    		'USA-9',   	'299',  'AKST9AKDT',                                            'United States-Alaska',            			'America/Anchorage',                'TZD+9',    '37', 		'Alaska'),
												('5', '-08:00',   				'4',			'-08 1 1',		'America/Los_Angeles',              '4',		'4',    		'8',    	'America/Los_Angeles',  '-480',     	'-80002',   		'-8',   	'Pacific Standard/Daylight Time',       '(Pacific Time)',           'US-Pacific',       'PST',  '-28800',      	'USA-8',   	'310',  'PST8PDT',                                              'United States-Pacific',           			'America/Los_Angeles',              'TZE+8',    '39', 		'Pacific Time (US & Canada)'),
												('6', '-07:00',   				'9',			'-07 2 1',		'America/Denver',                   '5',		'5',   			'10',  		'America/Denver',       '-420',     	'-70002',   		'-7',   	'Mountain Standard/Daylight Time',      '(Mountain Time)',          'US-Mountain',      'MST',  '-25200',      	'USA-7',   	'310',  'MST7MDT',                                              'United States-Mountain',          			'America/Denver',                   'TZE+7',    '41', 		'Mountain Time (US & Canada)'),
												('8', '-05:00',   				'18',			'-05 2 1',		'America/New_York',                 '7',		'12',   		'14',   	'America/New_York',     '-300',     	'-50001',   		'-5',   	'Eastern Standard/Daylight Time',       '(Eastern Time)',           'US-Eastern',       'EST',  '-18000',      	'USA-5',   	'310',  'EST5EDT',                                              'United States-Eastern',           			'America/New_York',                 'TZE+5',    '47', 		'Eastern Time (US & Canada)'),
												('9', '-04:00',   				'20',			'-04 2 1',		'America/Halifax',                  '9',		'15',   		'16',   	'Etc/GMT-4',            '-240',     	'-40003',   		'-4',   	'Atlantic Standard/Daylight Time',      '(Atlantic Time)',          'CA-Atlantic',      'AST',  '-14400',      	'CAN-4',   	'310',  'AST4ADT',                                              'Canada(Halifax,Saint John)',           'America/Argentina/San_Juan',       'TZE+4',    '50', 		'Atlantic Time (Canada)'),
												('10', '-03:30',  				'26',			'-03.5 1 1',	'America/St_Johns',                 '10',		'18',   		'17',   	'Etc/GMT-3',            '-210',     	'',         		'-3',   	'Newfoundland Standard/Daylight Time',	'(Newfoundland)',           '',                 '',     '-12600',      	'CAN-3.5', 	'',     'NST+3:30NDT+2:30,M4.1.0/00:01:00,M10.5.0/00:01:00',		'Canada-New Foundland(St.Johns)',       'America/St_Johns',                 'TZE+3',    '51', 		'Newfoundland'),
												('11', '-03:00',  				'28',			'-03 1 1',		'America/Argentina/Buenos_Aires',   '11',		'19',   		'18',   	'Etc/GMT-3',            '-180',     	'-30002',   		'-3',   	'SA Eastern Standard Time',							'(Buenos Aires,Greenland)', 'AR-Buenos aires',  'ART',  '-10800',      	'ARG-3',   	'310',  'NST+3NDT+2,M4.1.0/00:01:00,M10.5.0/00:01:00',    			'Argentina(Buenos Aires)',              'America/Argentina/Buenos_Aires',   'TZE+3',    '51', 		'Buenos Aires'),
												('12', '-02:00',  				'31',			'-02 1 0',		'America/Sao_Paulo',                '13',		'22',   		'20',   	'Etc/GMT-2',            '-120',     	'-20001',   		'-2',   	'Mid-Atlantic Standard/Daylight Time',	'(Mid-Atlantic)',           '',                 '',     '-7200',       	'BRA-2',   	'',     'NST+2NDT+1,M4.1.0/00:01:00,M10.5.0/00:01:00',          'Brazil(no DST)',                       'Atlantic/South_Georgia',           'TZE+2',    '52', 		'Mid-Atlantic'),
												('13', '-01:00',  				'32',			'-01 1 2',		'Atlantic/Azores',                  '14',		'23',   		'22',   	'Etc/GMT-1',            '-60',      	'-10002',   		'-1',   	'Azores Standard/Daylight Time',				'',                         '',                 '',     '-3600',       	'PRT-1',   	'',     '',                                                     'Portugal(Azores)',                     'Atlantic/Azores',                  'TZE+1',    '0', 			'Azores'),
												('14', 'GMT',     				'33',			'+00 2 2',		'',																	'15',		'25',   		'24',   	'Etc/GMT',              '0',        	'2',        		'0',    	'GMT Standard/Daylight Time',						'(London,Lisbon)',          'IE-Dublin',        'GMT',  '0',           	'GBR-0',   	'',     'GMT+0IST-1,M3.5.0/01:00:00,M10.5.0/02:00:00',          'GMT',                                  'Europe/Dublin',                    'TZN+0',    '3', 			'Dublin'),
												('15', '+01:00',  				'43',			'+01 2 2',		'Europe/Brussels',                  '16',		'27',   		'26',   	'Etc/GMT+1',            '60',       	'10003',    		'+1',   	'W. Europe Standard/Daylight Time',			'(Rome,Paris,Madrid)',      'IT-Rome',          'CET',  '3600',       	'FRA+1',   	'',     'CET-1CEST-2,M3.5.0/02:00:00,M10.5.0/03:00:00',         'Italy(Rome)',                          'Europe/Paris',                     'TZN+1',    '4', 			'Paris'),
												('16', '+02:00',  				'61',			'+02 2 2',		'Europe/Paris',                     '17',		'32',   		'28',   	'Etc/GMT+2',            '120',      	'20002',    		'+2',   	'E. Europe Standard/Daylight Time',     '(Athens,Cairo)',           'GR-Athens',        'EET',  '7200',        	'EGY+2',   	'',     'EET-2EEST-3,M3.5.0/03:00:00,M10.5.0/04:00:00',         'Greece(Athens)',                       'Europe/Athens',                    'TZN+2',    '9', 			'Athens'),
												('17', '+03:00',  				'73',			'+03 1 8',		'Europe/Moscow',                    '18',		'38',   		'30',   	'Etc/GMT+3',            '180',      	'30002',    		'+3',   	'Russian Standard/Daylight Time',				'(Moscow,Baghdad)',         'RU-Moscow',        'MSK',  '10800',       	'RUS+3',   	'',     'MSK-3MSD,M3.5.0/2,M10.5.0/3',                          'Russia(Moscow)',                       'Asia/Baghdad',                     'TZN+3',    '13', 		'Baghdad'),
												('18', '+03:30',  				'74',			'',						'Asia/Tehran',                      '19',		'42',   		'31',   	'Etc/GMT+3',            '210',      	'35001',    		'+3',   	'Iran Standard/Daylight Time',					'(Tehran)',                 '',                 '',     '12600',      	'IRN+3.5', 	'',     '',                                                     'Iran(Teheran)',                        'Asia/Tehran',                      'TZN+3',    '16', 		'Tehran'),
												('19', '+04:00',  				'77',			'+04 1 0',		'Asia/Tbilisi',                     '20',		'43',   		'32',   	'Etc/GMT+4',            '240',      	'40001',    		'+4',   	'Arabian Standard Time',								'(Abu Dhabi)',              'OM-Muscat',        'GST',  '14400',       	'RUS+4',   	'',     'CET-1CEST-2,M3.5.0/02:00:00,M10.5.0/03:00:00',         'Georgia(Tbilisi)',                     'Asia/Dubai',                       'TZN+4',    '17', 		'Abu Dhabi'),
												('20', '+04:30',  				'77',			'',						'Asia/Tbilisi',                     '21',		'45',   		'33',   	'Etc/GMT+4',            '270',      	'45001',    		'+4',   	'Afghanistan Standard Time',						'(Kabul)',                  '',                 '',     '16200',      	'',        	'',     '',                                                     '',                                     'Asia/Dubai',                       'TZN+4',    '18', 		'Afghanistan'),
												('21', '+05:00',  				'82',			'+05 1 7',		'Asia/Karachi',                     '22',		'46',   		'34',   	'Etc/GMT+5',            '300',      	'50001',    		'+5',   	'West Asia Standard Time',							'(Islamabad,Karachi)',      '',                 '',     '18000',       	'RUS+5',   	'',     '',                                                     'Pakistan(Islamabad)',                  'Asia/Karachi',                     'TZN+5',    '21', 		'Islamabad'),
												('22', '+05:30',  				'84',			'+05.5 1 0',	'Asia/Karachi',                     '23',		'48',   		'35',   	'Etc/GMT+5',            '330',      	'55002',    		'+5',   	'India Standard Time',									'(New Delhi)',              '',                 'GMT',  '19800',       	'IND+5.5', 	'',     '',                                                  		'India(Calcutta)',                      'Asia/Karachi',                     'TZN+5',    '19', 		'Bombay'),
												('23', '+05:45',  				'84',			'',						'Asia/Karachi',                     '24',		'49',   		'35',   	'Etc/GMT+5',            '345',     		'57501',    		'+5',   	'Central Asia Standard Time',						'(Kathmandu)',              '',                 '',     '20700',				'',        	'',     '',                                                     '',                                     'Asia/Karachi',                     'TZN+5',    '21', 		''),
												('24', '+06:00',  				'86',			'+06 1 7',		'Asia/Novosibirsk',                 '25',		'50',   		'36',   	'Etc/GMT+6',            '360',      	'60001',    		'+6',   	'SE Asia Standard Time',								'',                         '',                 '',     '21600',     		'RUS+6',   	'',     '',                                                     'Russia(Novosibirsk,Omsk)',             'Asia/Dhaka',                       'TZN+6',    '22', 		'Dhaka'),
												('25', '+06:30',  				'86',			'',						'Asia/Bangkok',                     '26',		'53',   		'37',   	'Etc/GMT+6',            '390',      	'65001',    		'+6',   	'SE Asia Standard Time',								'(Yangon)',                 '',                 '',     '23400',      	'',        	'',     '',                                                     '',                                     'Asia/Bangkok',                     'TZN+6',    '23', 		'Bangkok'),
												('26', '+07:00',  				'88',			'+07 1 7',		'Asia/Bangkok',                     '27',		'54',   		'38',   	'Etc/GMT+7',            '420',      	'70001',    		'+7',   	'Taipei Standard Time',									'(Bangkok,Jakarta)',        '',                 '',     '',            	'RUS+7',   	'',     '',                                                     'Thailand(Bangkok)',                    'Asia/Bangkok',                     'TZN+7',    '23', 		''),
												('27', '+08:00',  				'90',			'+08 4 0',		'Asia/Singapore',                   '28',		'56',   		'40',   	'Etc/GMT+8',            '480',      	'80004',    		'+8',   	'China Standard/Daylight Time',					'(Beijing,HK,Singapore)',   'HK-Hong kong',     'HKS',  '28800',      	'SGP+8',   	'',     'SGT-8',                                                'Singapore(Singapore)',                 'Asia/Singapore',                   'TZN+8',    '28', 		'Beijing'),
												('28', '+09:00',  				'93',			'+09 1 0',		'Asia/Tokyo',                       '29',		'61',   		'42',   	'Etc/GMT+9',            '540',      	'90001',   			'+9',   	'Tokyo Standard Time',									'(Tokyo,Seoul)',            '',                 '',     '32400',       	'JPN+9',   	'',     '',                                                     'Korea(Seoul)',                         'Asia/Tokyo',                       'TZN+9',    '32', 		'Tokyo'),
												('29', '+09:30',  				'94',			'+09.5 1 10',	'Australia/Adelaide',               '30',		'64',   		'43',   	'Etc/GMT+9',            '570',      	'95001',    		'+9',   	'AUS Central Standard Time',						'(Adelaide)',               '',                 '',     '34200',       	'AUS+9.5', 	'',     '',                                                     'Australia(Adelaide)',                  'Australia/Adelaide',               'TZN+9',    '32', 		'Adelaide'),
												('30', '+10:00',  				'96',			'+10 2 4',		'Australia/Sydney',                 '31',		'66',   		'44',   	'Etc/GMT+10',           '600',      	'100001',   		'+10',  	'E. Australia Standard Time',						'(Sydney,Guam)',            '',                 '',     '36000',      	'AUS+10',  	'',     '',                                                     'Australia(Sydney,Melbourne,Canberra)', 'Australia/Melbourne',              'TZN+10',   '34', 		'Melbourne'),
												('31', '+11:00',  				'101',		'+11 1 0',		'Pacific/Noumea',                   '32',		'71',   		'46',   	'Etc/GMT+11',           '660',      	'110001',   		'+11',  	'Central Pacific Standard Time',				'(Solomon Is.)',            '',                 '',     '39600',      	'NCL+11',  	'',     '',                                                     'New Caledonia(Noumea)',                'Pacific/Noumea',                   'TZN+11',   '', 			'SolomanIs.'),
												('32', '+12:00',  				'102',		'+12 1 0',		'Pacific/Auckland',                 '33',		'72',   		'48',   	'Etc/GMT+12',           '720',      	'120002',   		'+12',  	'Fiji Standard Time',										'(Fiji,Auckland)',          '',                 '',     '43200',       	'RUS+12',  	'',     '',                                                     'New Zeland(Wellington,Auckland)',      'Pacific/Fiji',                     'TZN+12',   '35', 		'Fiji'),
												('33', '+13:00',  				'104',		'',						'Pacific/Tongatapu',                '34',		'',     		'50',   	'Etc/GMT+13',           '780',      	'130001',   		'+13',  	'New Zealand Standard/Daylight Time',		'',                         '',                 '',     '46800',      	'TON+13',  	'',     '',                                                     'Tonga(Nukualofa)',                     '',                                 'TZN+13',  	'', 			''),
												('34', '-07:00 No DST', 	'10',			'-07 1 0',		'America/Phoenix',									'5',		'5',				'10', 		'America/Phoenix',			'-420',				'-70001',				'-7',			'US Mountain Standard Time',						'(Mountain Time)',					'US-Mountain',			'MST',	'-25200',				'USA2-7',		'2880',	'MST7',																									'United States-MST no DST',							'US/Arizona',												'TZE+7', 		'40', 		'Mountain Time (US & Canada)'),
												('35', '-03:00 Brasilia',	'29',			'-03 1 1',		'America/Argentina/Buenos_Aires',		'11',		'19',   		'18',   	'Etc/GMT-3',            '-180',     	'-30002',   		'-3',   	'SA Eastern Standard Time',							'(Buenos Aires,Greenland)', 'AR-Buenos aires',  'ART',  '-10800',      	'ARG-3',  	'310',  'BRST+3BRDT+2,M10.3.0,M2.3.0',    											'Brazil(DST)',              						'America/Argentina/Buenos_Aires',   'TZE+3',  	'51', 		'Buenos Aires')
";


$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('aastra', '00085D')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('aastra', '0010BC')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('aastra', 'AC44F2')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('algo', '0022EE')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('and', '2046F9')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('audiocodes', '00908F')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '00036B')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '00000C')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '000142')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '000143')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '000163')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '000164')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '000196')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '000197')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '0001C7')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '0001C9')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '000F23')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '0013C4')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '0016C8')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001818')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '00175A')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001795')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001A2F')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001C58')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001DA2')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '002155')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '0021A0')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '002290')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '000E84')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '000E38')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '00070E')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001BD4')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001930')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '0019AA')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001D45')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001EF7')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '000E08')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '1CDF0F')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '30E4DB')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '34DBFD')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '380A20')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '381C1A')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '3CCE73')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '503DE5')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '54781A')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '580A20')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '58BFEA')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '649EF3')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '68EFBD')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '5475D0')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '70CA9B')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '708105')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '8843E1')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'A44C11')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'B4E9B0')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'C46413')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'C89C1D')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'D0D0FD')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'D824BD')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'E05FB9')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'E02F6D')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'ECE1A9')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '0014BF')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '0018F8')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'C471FE')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'CCEF48')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001AA1')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001B2A')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001C58')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '001D45')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '002155')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '002255')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '002290')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '002304')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '00260B')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', '0026CB')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'A4934C')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'E8EDF3')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'ACA016')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cisco', 'B8BEBF')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cortelco', '00A859')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('cyberdata', '0020F7')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('digium', '000FD3')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('grandstream', '000B82')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('htek', '001FC1')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('incom', '00032A')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('konftel', 'D4EA0E')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('mitel', '08000F')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('mocet', '001915')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('obihai', '9CADEF')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('obihai', 'B4AB2C')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('panasonic', '0080F0')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('panasonic', '080023')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('phoenix', '0050C2')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('panasonic', '0080F0')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('polycom', '0004F2')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('polycom', '00907A')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('polycom', '64167F')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('sangoma', '005058')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('snom', '000413')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('uniden', '00087B')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('vtech', '00122A')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('vtech', '14AEDB')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('xorcom', '642400')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `oui`) VALUES ('yealink', '001565')";

//Descriptions for Basefile
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Aastra', 		'x+#|xx+*')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Algo', 		'x+#|xx+*')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('And', 			'x+#|xx+*')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Audiocodes', 	'x+#|xx+*')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Cisco', 		'(*x.|**xx|[3469]11|0|00|[2-9]xxxxxx|1xxx[2-9]xxxxxxS0|xxxxxxxxxxxx.)')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Cortelco', 	'x+#|xx+*')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Cyberdata', 	'x+#|xx+*')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Digium', 		'[0-8]xxxxx|911|9411|9611|9011xxx.T3|91xxxxxxxxxx|9[2-9]xxxxxx|*xx.T3|[0-8]xx.T3')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Grandstream', 	'{x+|*x+|**x+|[0-9*#]+}')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Htek',			'{[x*]+}')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Incom', 		'')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Konftel', 		'')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Mitel', 		'x+#|xx+*')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Mocet', 		'x+#|xx+*')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Obihai', 		'(*x.|xx.|911)')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Panasonic', 	'')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Phoenix', 		'x+#|xx+*')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Polycom', 		'[2-9]11|0T|011xxx.T|[0-1][2-9]xxxxxxxxx|[2-9]xxxxxxxxx|[2-9]xxxT')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Sangoma', 		'{[x*]+}')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Snom', 		'x+#|xx+*')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Uniden', 		'x+#|xx+*')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Vtech', 		'x+P')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Xorcom', 		'')";
$sql[] = "INSERT INTO `endpoint_brand` (`brand`, `dialpattern`) VALUES ('Yealink', 		'')";



//api xmls
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Apps', 'http://__line1Dest__:__restapps__/applications.php/restapps/main?user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Call Flow', 'http://__line1Dest__:__restapps__/applications.php/daynight/main?user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Call Forward', 'http://__line1Dest__:__restapps__/applications.php/callforward/main?user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Conference', 'http://__line1Dest__:__restapps__/applications.php/conferences/main?user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Contacts', 'http://__line1Dest__:__restapps__/applications.php/contactmanager/main?linestate=$\$LINESTATE$$&user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-DND', 'http://__line1Dest__:__restapps__/applications.php/donotdisturb/main?user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Follow Me', 'http://__line1Dest__:__restapps__/applications.php/findmefollow/main?user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Login', 'http://__line1Dest__:__restapps__/applications.php/endpoint/main?user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Parking', 'http://__line1Dest__:__restapps__/applications.php/parking/main?linestate=$\$LINESTATE$$&user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Presence', 'http://__line1Dest__:__restapps__/applications.php/presencestate/main?user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Queues', 'http://__line1Dest__:__restapps__/applications.php/queues/main?user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Queue Agent', 'http://__line1Dest__:__restapps__/applications.php/queues/agent?user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Time Conditions', 'http://__line1Dest__:__restapps__/applications.php/timeconditions/main?user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Transfer VM', 'http://__line1Dest__:__restapps__/applications.php/voicemail/transfer?linestate=$\$LINESTATE$$&user=')";
$sql[] = "INSERT INTO `endpoint_xml` (`api`, `app_name`, `url`) VALUES ('1', 'REST-Voicemail', 'http://__line1Dest__:__restapps__/applications.php/voicemail/main?linestate=$\$LINESTATE$$&user=')";


// run what we have to create tables
foreach ($sql as $q) {
	$result = $db->query($q);
	if($db->IsError($result)){
		die_freepbx($result->getDebugInfo());
	}
}
unset($sql);

//get globals
$sipSettings = $db->getAll("Select * from sipsettings", DB_FETCHMODE_ASSOC);
foreach($sipSettings as $k=>$v){
	if($v['keyword'] == 'externhost_val'){$ext=$v['data'];}
}


$listen = system("/bin/grep '^Listen.*' /etc/httpd/conf/httpd.conf");
$port = substr($listen, 7);
$netface = endpoint_get_ifs();
$int = $netface[0]['IPADDR'];

include('install/aastraInstall.php');
include('install/algoInstall.php');
include('install/andInstall.php');
include('install/audiocodesInstall.php');
include('install/ciscoInstall.php');
include('install/cortelcoInstall.php');
include('install/cyberdataInstall.php');
include('install/digiumInstall.php');
include('install/grandstreamInstall.php');
include('install/htekInstall.php');
include('install/incomInstall.php');
include('install/konftelInstall.php');
include('install/mitelInstall.php');
include('install/mocetInstall.php');
include('install/obihaiInstall.php');
include('install/panasonicInstall.php');
include('install/phoenixInstall.php');
include('install/polycomInstall.php');
include('install/sangomaInstall.php');
include('install/snomInstall.php');
include('install/unidenInstall.php');
include('install/vtechInstall.php');
include('install/yealinkInstall.php');
include('install/xorcomInstall.php');

if ($newInstall == true) {
	$sql[] = "INSERT INTO `endpoint_global` (`key`, `values`) VALUES ('internal', '$int'), ('external', '$ext'), ('sipPort', '5060'), ('port', '$port'), ('profile', 'sample'), ('admin_password', '222222'), ('no_vm_password', '1234'), ('dhcp', '1'), ('ipaddress', 'both'), ('xml-api', 'Y'), ('user_password', '111111')";
	$sql[] = "INSERT INTO `endpoint_global` (`key`, `values`) VALUES ('migrate', '12')";
}

//Check if internal is set
$test = $db->query("SELECT `values` FROM endpoint_global WHERE `key` = 'internal'");
if($db->IsError($test)){
	$sql[] = "INSERT INTO `endpoint_global` (`key`, `values`) VALUES ('internal', '$int')";
}

$fdb = \FreePBX::Database();
$query = "SELECT * FROM endpoint_templates WHERE `brand` = 'sangoma' AND `template_name` = 'sangoma_default'";
$stmt = $fdb->prepare($query);
$stmt->execute();
if($stmt->rowCount() < 1){
	$query = "SELECT * FROM endpoint_templates WHERE `brand` = 'sangoma' AND `default` = '1'";
	$stmt = $fdb->prepare($query);
	$stmt->execute();
	if($stmt->rowCount() < 1){
		$defaultTemplate = '1';
	} else {
		$defaultTemplate = '';
	}
	//install default template
	$sql[] = "INSERT INTO `endpoint_templates` (`brand`, `default`, `template_name`, `destination`, `focus`, `answer`, `mute`, `barge`, `offhook`, `stutter`, `timeout`, `toneset`, `time_server`, `time_server_1`, `time_server_2`, `time_server_3`, `timezone`, `protocol`, `ftpuser`, `ftppass`, `ftpserver`, `extra`, `ext`, `missed`, `volume`, `echo`, `callwaiting`, `features`, `background`, `outgoing`, `firmware`, `multicastAddress`, `multicastEnable`, `lineLabel`, `daylight`, `dialpattern`, `models`, `wEnable1`, `wssid1`, `wsecurity1`, `wWEPBits1`, `wWPAPSKPass1`, `wWPAPSKKey1`, `hotline`, `hotlineDest`, `internalDefault`, `externalDefault`) 
																			VALUES ('sangoma','$defaultTemplate','sangoma_default','" . (!empty($int) ? $int : '__internal__') . "','1','2','','0','','','','','','0.us.pool.ntp.org','','','7','1','','','" . (!empty($int) ? $int : '__internal__') . "','','','0','0','0','1',NULL,'None','None',' ','','0','1','1','x+#|xx+*','','','','','','','','0','', '1', '')";
	$sql[] = "INSERT INTO `endpoint_buttons` (`brand`, `template_name`, `key`, `value`, `daylight`) VALUES 
		('sangoma','sangoma_default','S300_linekeys_1_type','1',NULL),
		('sangoma','sangoma_default','S300_linekeys_1_acct','account1',NULL),
		('sangoma','sangoma_default','S300_linekeys_2_type','1',NULL),
		('sangoma','sangoma_default','S300_linekeys_2_acct','account1',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_At2_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_At2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_At1_value','Transfer',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_At1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ri4_value','Cancel',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ri4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ri3_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ri3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ri2_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ri2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ri1_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ri1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Se4_value','Cancel',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Se4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Se3_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Se3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Se2_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Se2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Se1_value','Transfer',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Se1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Co4_value','Cancel',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Co4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Co3_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Co3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Co2_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Co2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Co1_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Co1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Di4_value','Cancel',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Di4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Di3_value','Delete',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Di3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Di2_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Di2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Di1_value','Send',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Di1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id4_value','Menu',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id4_label','Menu',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id3_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id3_label','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id2_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id2_label','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id1_value','History',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id1_label','History',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Id1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_At3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_At3_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_At4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_At4_value','Cancel',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ca1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ca1_value','NewCall',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ca2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ca2_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ca3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ca3_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ca4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ca4_value','Cancel',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ac1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ac1_value','Answer',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ac2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ac2_value','Forward',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ac3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ac3_value','Silence',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ac4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ac4_value','Reject',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ta1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ta1_value','Transfer',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ta2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ta2_value','Hold',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ta3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ta3_value','Conference',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ta4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ta4_value','Cancel',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ho1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ho1_value','Transfer',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ho2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ho2_value','Resume',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ho3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ho3_value','NewCall',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ho4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Ho4_value','Cancel',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_He1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_He1_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_He2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_He2_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_He3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_He3_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_He4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_He4_value','Cancel',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Pr1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Pr1_value','Transfer',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Pr2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Pr2_value','Send',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Pr3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Pr3_value','Delete',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Pr4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Pr4_value','Cancel',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Br1_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Br1_value','Empty',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Br2_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Br2_value','Hold',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Br3_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Br3_value','Split',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Br4_type','horizontal',NULL),
		('sangoma','sangoma_default','S300_horsoftkeys_Br4_value','Cancel',NULL),
		('sangoma','sangoma_default','S500_linekeys_1_type','1',NULL),
		('sangoma','sangoma_default','S500_linekeys_1_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_2_type','1',NULL),
		('sangoma','sangoma_default','S500_linekeys_2_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_3_type','1',NULL),
		('sangoma','sangoma_default','S500_linekeys_3_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_4_type','9',NULL),
		('sangoma','sangoma_default','S500_linekeys_4_label','Intercom',NULL),
		('sangoma','sangoma_default','S500_linekeys_4_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_19_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_19_xml','REST-Voicemail',NULL),
		('sangoma','sangoma_default','S500_linekeys_19_label','Voicemail',NULL),
		('sangoma','sangoma_default','S500_linekeys_19_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_18_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_18_xml','REST-Transfer VM',NULL),
		('sangoma','sangoma_default','S500_linekeys_18_label','Transfer VM',NULL),
		('sangoma','sangoma_default','S500_linekeys_18_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_17_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_17_xml','REST-Time Conditions',NULL),
		('sangoma','sangoma_default','S500_linekeys_17_label','Time Conditions',NULL),
		('sangoma','sangoma_default','S500_linekeys_17_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_16_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_16_xml','REST-Queue Agent',NULL),
		('sangoma','sangoma_default','S500_linekeys_16_label','Queue Agent',NULL),
		('sangoma','sangoma_default','S500_linekeys_16_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_15_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_15_xml','REST-Queues',NULL),
		('sangoma','sangoma_default','S500_linekeys_15_label','Queues',NULL),
		('sangoma','sangoma_default','S500_linekeys_15_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_14_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_14_xml','REST-Presence',NULL),
		('sangoma','sangoma_default','S500_linekeys_14_label','Presence',NULL),
		('sangoma','sangoma_default','S500_linekeys_14_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_13_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_13_xml','REST-Parking',NULL),
		('sangoma','sangoma_default','S500_linekeys_13_label','Parking',NULL),
		('sangoma','sangoma_default','S500_linekeys_13_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_12_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_12_xml','REST-Login',NULL),
		('sangoma','sangoma_default','S500_linekeys_12_label','Login',NULL),
		('sangoma','sangoma_default','S500_linekeys_12_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_11_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_11_xml','REST-Follow Me',NULL),
		('sangoma','sangoma_default','S500_linekeys_11_label','Follow Me',NULL),
		('sangoma','sangoma_default','S500_linekeys_11_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_10_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_10_xml','REST-DND',NULL),
		('sangoma','sangoma_default','S500_linekeys_10_label','DND',NULL),
		('sangoma','sangoma_default','S500_linekeys_10_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_9_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_9_xml','REST-Contacts',NULL),
		('sangoma','sangoma_default','S500_linekeys_9_label','Contacts',NULL),
		('sangoma','sangoma_default','S500_linekeys_9_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_8_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_8_xml','REST-Conference',NULL),
		('sangoma','sangoma_default','S500_linekeys_8_label','Conference',NULL),
		('sangoma','sangoma_default','S500_linekeys_8_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_7_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_7_xml','REST-Call Forward',NULL),
		('sangoma','sangoma_default','S500_linekeys_7_label','Call Forward',NULL),
		('sangoma','sangoma_default','S500_linekeys_7_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_6_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_6_xml','REST-Call Flow',NULL),
		('sangoma','sangoma_default','S500_linekeys_6_label','Call Flow',NULL),
		('sangoma','sangoma_default','S500_linekeys_6_type','14',NULL),
		('sangoma','sangoma_default','S500_linekeys_5_acct','account1',NULL),
		('sangoma','sangoma_default','S500_linekeys_5_xml','REST-Apps',NULL),
		('sangoma','sangoma_default','S500_linekeys_5_label','Apps',NULL),
		('sangoma','sangoma_default','S500_linekeys_5_type','14',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id1_label','History',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id1_value','History',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id2_label','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id2_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id3_label','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id3_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id4_label','Menu',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Id4_value','Menu',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Di1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Di1_value','Send',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Di2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Di2_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Di3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Di3_value','Delete',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Di4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Di4_value','Cancel',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Co1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Co1_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Co2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Co2_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Co3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Co3_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Co4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Co4_value','Cancel',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Se1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Se1_value','Transfer',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Se2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Se2_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Se3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Se3_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Se4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Se4_value','Cancel',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ri1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ri1_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ri2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ri2_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ri3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ri3_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ri4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ri4_value','Cancel',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_At1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_At1_value','Transfer',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_At2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_At2_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_At3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_At3_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_At4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_At4_value','Cancel',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ca1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ca1_value','NewCall',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ca2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ca2_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ca3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ca3_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ca4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ca4_value','Cancel',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ac1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ac1_value','Answer',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ac2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ac2_value','Forward',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ac3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ac3_value','Silence',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ac4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ac4_value','Reject',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ta1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ta1_value','Transfer',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ta2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ta2_value','Hold',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ta3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ta3_value','Conference',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ta4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ta4_value','Cancel',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ho1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ho1_value','Transfer',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ho2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ho2_value','Resume',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ho3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ho3_value','NewCall',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ho4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Ho4_value','Cancel',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_He1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_He1_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_He2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_He2_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_He3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_He3_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_He4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_He4_value','Cancel',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Pr1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Pr1_value','Transfer',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Pr2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Pr2_value','Send',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Pr3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Pr3_value','Delete',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Pr4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Pr4_value','Cancel',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Br1_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Br1_value','Empty',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Br2_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Br2_value','Hold',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Br3_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Br3_value','Split',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Br4_type','horizontal',NULL),
		('sangoma','sangoma_default','S500_horsoftkeys_Br4_value','Cancel',NULL),
		('sangoma','sangoma_default','S700_linekeys_1_type','1',NULL),
		('sangoma','sangoma_default','S700_linekeys_1_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_2_type','1',NULL),
		('sangoma','sangoma_default','S700_linekeys_2_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_3_type','1',NULL),
		('sangoma','sangoma_default','S700_linekeys_3_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_4_type','9',NULL),
		('sangoma','sangoma_default','S700_linekeys_4_label','Intercom',NULL),
		('sangoma','sangoma_default','S700_linekeys_4_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_19_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_19_xml','REST-Voicemail',NULL),
		('sangoma','sangoma_default','S700_linekeys_19_label','Voicemail',NULL),
		('sangoma','sangoma_default','S700_linekeys_19_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_18_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_18_xml','REST-Transfer VM',NULL),
		('sangoma','sangoma_default','S700_linekeys_18_label','Transfer VM',NULL),
		('sangoma','sangoma_default','S700_linekeys_18_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_17_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_17_xml','REST-Time Conditions',NULL),
		('sangoma','sangoma_default','S700_linekeys_17_label','Time Conditions',NULL),
		('sangoma','sangoma_default','S700_linekeys_17_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_16_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_16_xml','REST-Queue Agent',NULL),
		('sangoma','sangoma_default','S700_linekeys_16_label','Queue Agent',NULL),
		('sangoma','sangoma_default','S700_linekeys_16_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_15_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_15_xml','REST-Queues',NULL),
		('sangoma','sangoma_default','S700_linekeys_15_label','Queues',NULL),
		('sangoma','sangoma_default','S700_linekeys_15_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_14_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_14_xml','REST-Presence',NULL),
		('sangoma','sangoma_default','S700_linekeys_14_label','Presence',NULL),
		('sangoma','sangoma_default','S700_linekeys_14_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_13_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_13_xml','REST-Parking',NULL),
		('sangoma','sangoma_default','S700_linekeys_13_label','Parking',NULL),
		('sangoma','sangoma_default','S700_linekeys_13_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_12_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_12_xml','REST-Login',NULL),
		('sangoma','sangoma_default','S700_linekeys_12_label','Login',NULL),
		('sangoma','sangoma_default','S700_linekeys_12_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_11_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_11_xml','REST-Follow Me',NULL),
		('sangoma','sangoma_default','S700_linekeys_11_label','Follow Me',NULL),
		('sangoma','sangoma_default','S700_linekeys_11_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_10_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_10_xml','REST-DND',NULL),
		('sangoma','sangoma_default','S700_linekeys_10_label','DND',NULL),
		('sangoma','sangoma_default','S700_linekeys_10_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_9_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_9_xml','REST-Contacts',NULL),
		('sangoma','sangoma_default','S700_linekeys_9_label','Contacts',NULL),
		('sangoma','sangoma_default','S700_linekeys_9_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_8_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_8_xml','REST-Conference',NULL),
		('sangoma','sangoma_default','S700_linekeys_8_label','Conference',NULL),
		('sangoma','sangoma_default','S700_linekeys_8_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_7_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_7_xml','REST-Call Forward',NULL),
		('sangoma','sangoma_default','S700_linekeys_7_label','Call Forward',NULL),
		('sangoma','sangoma_default','S700_linekeys_7_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_6_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_6_xml','REST-Call Flow',NULL),
		('sangoma','sangoma_default','S700_linekeys_6_label','Call Flow',NULL),
		('sangoma','sangoma_default','S700_linekeys_6_type','14',NULL),
		('sangoma','sangoma_default','S700_linekeys_5_acct','account1',NULL),
		('sangoma','sangoma_default','S700_linekeys_5_xml','REST-Apps',NULL),
		('sangoma','sangoma_default','S700_linekeys_5_label','Apps',NULL),
		('sangoma','sangoma_default','S700_linekeys_5_type','14',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id1_label','History',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id1_value','History',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id2_label','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id2_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id3_label','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id3_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id4_label','Menu',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Id4_value','Menu',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Di1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Di1_value','Send',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Di2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Di2_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Di3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Di3_value','Delete',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Di4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Di4_value','Cancel',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Co1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Co1_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Co2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Co2_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Co3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Co3_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Co4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Co4_value','Cancel',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Se1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Se1_value','Transfer',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Se2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Se2_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Se3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Se3_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Se4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Se4_value','Cancel',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ri1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ri1_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ri2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ri2_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ri3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ri3_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ri4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ri4_value','Cancel',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_At1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_At1_value','Transfer',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_At2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_At2_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_At3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_At3_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_At4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_At4_value','Cancel',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ca1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ca1_value','NewCall',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ca2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ca2_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ca3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ca3_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ca4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ca4_value','Cancel',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ac1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ac1_value','Answer',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ac2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ac2_value','Forward',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ac3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ac3_value','Silence',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ac4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ac4_value','Reject',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ta1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ta1_value','Transfer',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ta2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ta2_value','Hold',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ta3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ta3_value','Conference',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ta4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ta4_value','Cancel',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ho1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ho1_value','Transfer',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ho2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ho2_value','Resume',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ho3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ho3_value','NewCall',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ho4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Ho4_value','Cancel',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_He1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_He1_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_He2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_He2_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_He3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_He3_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_He4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_He4_value','Cancel',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Pr1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Pr1_value','Transfer',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Pr2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Pr2_value','Send',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Pr3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Pr3_value','Delete',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Pr4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Pr4_value','Cancel',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Br1_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Br1_value','Empty',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Br2_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Br2_value','Hold',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Br3_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Br3_value','Split',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Br4_type','horizontal',NULL),
		('sangoma','sangoma_default','S700_horsoftkeys_Br4_value','Cancel',NULL)
	";
}

foreach ($sql as $q) {
	$result = $db->query($q);
	if($db->IsError($result)){
		dbug($q);
		die_freepbx($result->getDebugInfo());
	}
}

if(!file_exists('/tftpboot/images')){system('/bin/mkdir /tftpboot/images', $result);}
if(!file_exists('/tftpboot/images/originals')){system('/bin/mkdir /tftpboot/images/originals', $result);}
if(!file_exists('/tftpboot/images/formatted')){system('/bin/mkdir /tftpboot/images/formatted', $result);}
if(!file_exists('/tftpboot/firmwaredownloads')){system('/bin/mkdir /tftpboot/firmwaredownloads', $result);}
$pwd = dirname(__FILE__);
if(!file_exists($pwd . '/images')){system("/bin/ln -s /tftpboot/images/ $pwd/images", $result);}
if(file_exists($pwd . '/images/images')){system("/bin/unlink /tftpboot/images/images", $result);}

if(!function_exists('endpoint_template_changed')){
	//mark all extensions using a specific template as "needs rebuild"
	function endpoint_template_changed($template = null, $brand = null){
	        global $db;
	        if(empty($template) || empty($brand)){
	                //probably install
	                $query = "UPDATE endpoint_extensions SET `rebuild` = '1'";
	        } else {
	                $query = "UPDATE endpoint_extensions SET `rebuild` = '1' WHERE `brand` = '$brand' AND `template` = '$template'";
	        }
	        $sql = $db->query($query);
	}
}


if ($newInstall != true) {
	endpoint_template_changed(); //mark all extensions as changed
}
//grandstream sample phonebook
if(!file_exists('/tftpboot/phonebook.xml')){
	$phonebook = '<AddressBook>
  <Contact>
    <LastName>Enter last name here</LastName>
    <FirstName>Enter first name here</FirstName>
    <Phone>
      <phonenumber>Enter phone number here</phonenumber>
      <accountindex>Enter account index here</accountindex>
    </Phone>
    <Groups>
      <groupid>Enter group ID here</groupid>
    </Groups>
  </Contact>
</AddressBook>';
	$fileloc = '/tftpboot/phonebook.xml';
	file_put_contents($fileloc, $phonebook);
	$chmods = system("/bin/chmod 755 " . $fileloc, $retval);
}

	unset($sql);

	//check if we need to migrate to 12
	//put it here because we rebuild configs and need the rest in place
	$q = "SELECT * FROM endpoint_global where `key` = 'migrate'";
	$r = $db->getAll($q, DB_FETCHMODE_ASSOC);

	if(!empty($r)){
		foreach($r as $key){
			if(!empty($key['key']) || $key['key'] == 'migrate'){
				if($key['values'] < '12'){
					include("migrate12.php");
				}
			} else {
				include("migrate12.php");
			}
		}
	} else {
		include("migrate12.php");
	}

//write out sangoma defaults even if not activated
//get global settings
$qGlobal = "SELECT * FROM endpoint_global";
$rGlobal = $db->getAll($qGlobal, DB_FETCHMODE_ASSOC);
if($db->IsError($rGlobal)){die_freepbx($rGlobal->getDebugInfo()); }
foreach($rGlobal as $key=>$value){
	$g_values[$value['key']] = $value['values'];
}

$qGlobal = 'SELECT * FROM sysadmin_options';
$rGlobal = $db->getAll($qGlobal, DB_FETCHMODE_ASSOC);
if($db->IsError($rGlobal)){die_freepbx($rGlobal->getDebugInfo()); }
foreach($rGlobal as $key=>$value){
	$g_values[$value['key']] = $value['value'];
}

$basefile = '';
$basefile .= "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
$basefile .= "  <hl_provision version=\"1\">\n";
$basefile .= "    <config version=\"1\">\n";
$basefile .= "      <P2>" . $g_values['admin_password'] . "</P2>\n";
if(!empty($values['internal'])){
	$basefile .= "      <P41200>14</P41200>\n";
	$basefile .= "      <P41300>http://" . $g_values['internal'] . ":" . $g_values['restapps'] . "/applications.php/endpoint/login?user=0000</P41300>\n";
	$basefile .= "      <P41400>Login Int</P41400>\n";
	$basefile .= "      <P42200>14</P42200>\n";
	$basefile .= "      <P42300>http://" . $g_values['internal'] . ":" . $g_values['restapps'] . "/applications.php/endpoint/login?user=0000</P42300>\n";
}
if(!empty($values['external'])){
	$basefile .= "      <P41201>14</P41201>\n";
	$basefile .= "      <P41301>http://" . $g_values['external'] . ":" . $g_values['restapps'] . "/applications.php/endpoint/loginexternal?user=0000</P41301>\n";
	$basefile .= "      <P41401>Login Ext</P41401>\n";
	$basefile .= "      <P42201>14</P42201>\n";
	$basefile .= "      <P42301>http://" . $g_values['external'] . ":" . $g_values['restapps'] . "/applications.php/endpoint/loginexternal?user=0000</P42301>\n";
}
$basefile .= "    </config>\n";
$basefile .= "  </hl_provision>\n";

$commons = array(
	'cfg0300.xml',
	'cfg0500.xml',
	'cfg0700.xml'
);

foreach($commons as $file){
	$fileloc = '/tftpboot/' . $file;
	file_put_contents($fileloc, $basefile);
	$chmods = system("/bin/chmod 755 " . $fileloc, $retval);
}

if(file_exists('/etc/schmooze/schmooze.zl')){
	if(function_exists('endpoint_WriteAastraCfg')){
		endpoint_WriteAastraCfg();
	}
	if(function_exists('endpoint_write_sangoma_commons')){
		endpoint_write_sangoma_commons();
	}
	if(function_exists('endpoint_write_yealink_commons')){
		endpoint_write_yealink_commons();
	}
}

if(!file_exists($pwd . '/assets/less/cache')){system('/bin/mkdir ' . $pwd . '/assets/less/cache', $result);}
if(file_exists($pwd . '/assets/less/cache')){system('/bin/chmod 775 ' . $pwd . '/assets/less/cache', $result);}

//we only install recommended for digium, so we will skip this at install.
//shell_exec($amp_conf['AMPBIN'] . '/endpoint_firmware.php > /dev/null & echo $!');

endpoint_get_config('asterisk');

function endpoint_get_ifs() {
	//scan directory for all possible interface config files
	$ifs = scandir('/etc/sysconfig/network-scripts/');
	//loop through the files we found
	foreach ($ifs as $if) {
		if (strpos(trim($if),'ifcfg-eth') === 0 OR strpos(trim($if),'ifcfg-wlan') === 0) {
			$my_if =  str_replace('ifcfg-', '', $if);

			//if its an eth or a wlan, parse the file and add to the array
			$my_if_file = '/etc/sysconfig/network-scripts/' . $if;
			if (file_exists($my_if_file) && is_readable($my_if_file)) {
				$comment = array(';', '#');
				//read file as an array
				$line = file($my_if_file, FILE_SKIP_EMPTY_LINES | FILE_IGNORE_NEW_LINES);
				foreach ($line as $ln) {
					if (!in_array(substr($ln, 0, 1), $comment)) {
						$part = explode('=', $ln);
						//dbug('$f_line', $f_line);
						$this_face[trim($part[0])] = trim($part[1]);
					}
				}
			}
			//ensure we have DEVICE set
			if (!isset($this_face['DEVICE'])) {
				$this_face['DEVICE'] = $my_if;
			}
			//make sure bootproto isnt set to static
			if (isset($this_face['BOOTPROTO']) && $this_face['BOOTPROTO'] == 'static') {
				$this_face['BOOTPROTO'] = 'none';
			}
			//set possible values so there not blank
			$this_face['BOOTPROTO']	= isset($this_face['BOOTPROTO'])	? $this_face['BOOTPROTO']	: '';
			$this_face['ONBOOT']	= isset($this_face['ONBOOT'])		? $this_face['ONBOOT']		: '';
			$this_face['IPADDR']	= isset($this_face['IPADDR'])		? $this_face['IPADDR']		: '';
			$this_face['NETMASK']	= isset($this_face['NETMASK'])		? $this_face['NETMASK']		: '';
			$this_face['GATEWAY']	= isset($this_face['GATEWAY'])		? $this_face['GATEWAY']		: '';
			$this_face['HOSTNAME']	= isset($this_face['HOSTNAME'])		? $this_face['HOSTNAME']	: '';
			$this_face['ONBOOT']	= isset($this_face['ONBOOT'])		? $this_face['ONBOOT']		: '';
			$this_face['HWADDR']	= isset($this_face['HWADDR'])		? $this_face['HWADDR']		: '';
			//add a mac address if its missing and we can find it
			if (!$this_face['HWADDR'] && $this_face['type'] == 'physical') {
				//get results from `ip`
				exec('ip -f link addr show ' . $this_face['DEVICE'], $ip_ret);
				if ($ip_ret) {
					$r = preg_split('/\s+/', $ip_ret[1]); //split based on whitespace
					if ($r[1] == 'link/ether') { //make sure array is formated as we excpect it
						$this_face['HWADDR'] = $r[2];
					}
				}
			}
			//add settings to array
			$ret[] = $this_face;
		}
	}

	//now, iterate over the phsicaly adapters to ensure that we didnt miss any
	if(isset($pys_net) && is_array($pys_net)){
            foreach ($pys_net as $pys => $stat) {
		if  (strpos($pys,'eth') === 0 OR strpos($pys,'wlan') === 0) {
                    if (!isset($var['netface'][$pys])) {
                        $this_face['DEVICE']	= $pys;
                        $this_face['BOOTPROTO']	= '';
                        $this_face['ONBOOT']	= '';
                        $this_face['IPADDR']	= '';
                        $this_face['NETMASK']	= '';
                        $this_face['GATEWAY']	= '';
                        $this_face['HOSTNAME']	= '';
                        $this_face['stats'] 	= $stat;
                        $this_face['type'] 		= 'physical';
                        //add a mac address if we can find it
                        //get results from `ip`
                        exec('ip -f link addr show ' . $this_face['DEVICE'], $ip_ret);
                        if ($ip_ret) {
                            $r = preg_split('/\s+/', $ret[1]); //split based on whitespace
                            if ($r[1] == 'link/ether') { //make sure array is formated as we excpect it
                                $this_face['HWADDR'] = $r[2];
                            }
                        }
                        $ret[] = $this_face;
                    }
		}
            }
        }
	return $ret;
}

if(FreePBX::Modules()->checkStatus("endpoint",MODULE_STATUS_NEEDUPGRADE) && FreePBX::Modules()->checkStatus('userman') && FreePBX::Modules()->checkStatus('ucp')) {
	$info = FreePBX::Modules()->getInfo("endpoint");
	if(version_compare_freepbx($info['endpoint']['dbversion'], "13.0.13", "<")) {
		$users = FreePBX::Userman()->getAllUsers();
		foreach($users as $user) {
			$assigned = FreePBX::Ucp()->getSettingByID($user['id'],'Endpoint','assigned');
			if(!empty($assigned)) {
				FreePBX::Ucp()->setSettingByID($user['id'],'Endpoint','enable',true);
			}
		}
	}
}
