<?php
//Namespace should be FreePBX\Console\Command
namespace FreePBX\Console\Command;

//Symfony stuff all needed add these
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;
//Tables
use Symfony\Component\Console\Helper\TableHelper;
//Process
use Symfony\Component\Process\Process;

use Symfony\Component\Console\Helper\Table;
class Pagingpro extends Command {
	protected function configure(){
		$this->setName('pagingpro')
			->setDescription(_('Paging Pro'))
			->setDefinition(array(
				new InputOption('clean', 'c', InputOption::VALUE_NONE, _('Cleanup stale pages and add needed pages')),
				new InputOption('execute', 'e', InputOption::VALUE_REQUIRED, _('Execute a scheduled page now')),
				new InputOption('list', 'l', InputOption::VALUE_OPTIONAL, _('List Scheduled Pages'))
			));
	}
	protected function execute(InputInterface $input, OutputInterface $output){
		if(!\FreePBX::Pagingpro()->isLicensed()) {
			$output->writeln("<error>"._("Paging Pro is not Authorized")."</error>");
			exit(1);
		}
		$debug = $output->getVerbosity() >= OutputInterface::VERBOSITY_VERBOSE;
		$execute = $input->getOption('execute');
		if(isset($execute)) {
			$sql = "SELECT * FROM pagingpro WHERE enable_scheduler=1 AND page_id=".$execute;
			$sth = \FreePBX::Database()->prepare($sql);
			$sth->execute();
			$page = $sth->fetch(\PDO::FETCH_ASSOC);
			if(!empty($page)) {
				$options = array(
					'p' => $execute
				);
				pp_execute_pager($options);
			} else {
				$output->writeln("<error>"._("Page schedule does not exist!")."</error>");
			}

			exit(0);
		}

		$clean = $input->getOption('clean');
		if($clean) {
			$o = $debug ? $output : null;
			\FreePBX::Pagingpro()->cleanupStaleCrons($o);
			exit(0);
		}

		$list = $input->hasParameterOption('--list');
		if(isset($list)) {
			$id = $input->getOption('list');
			$sql = "SELECT * FROM pagingpro_scheduler_crons";
			$sth = \FreePBX::Database()->prepare($sql);
			$sth->execute();
			$crons = $sth->fetchAll(\PDO::FETCH_ASSOC);
			$crontabs = \FreePBX::Cron()->getAll();
			$rows = array();
			foreach($crons as $cron) {
				if(!empty($id) && $cron['page_id'] != $id) {
					continue;
				}
				$cron['ct'] = false;
				foreach($crontabs as $c) {
					if(preg_match('/pagepro-scheduler\.php\s*-p\s*(\d*)\s*-t\s*(\d*)/',$c,$matches)) {
						$cron['ct'] = true;
					}
				}
				$rows[] = array($cron['page_id'],$cron['time'],($cron['ct']?_("Yes"):_("No")));
			}

			$table = new Table($output);
			$table->setHeaders(array(_('Page ID'),_('Time'),_("Cron Exists")));
			$table->setRows($rows);
			$table->render();
		}
	}
}
