#!/bin/bash

PHP=/var/www/html/admin/modules/restapps/restapps.php

if [[ `id -u` == 0 ]]
then
	SU="su asterisk -c "
else
	SU=""
fi

# Check to see if there's any old start-restapps.sh scripts
# hanging around
OLDSTART=$(pidof -x start-restapps.sh)
if [[ "$OLDSTART" ]]; then
	echo "Killing old startup script ($OLDSTART)"
	kill -9 $OLDSTART
fi

# Check to see if restapps is already running
SCRIPT=restapps.php
PIDS=$(pidof -x $SCRIPT)
if [[ "$PIDS" ]]; then
	echo "Killing current Restapps Daemon ($PIDS)"
	kill -9 $PIDS
fi

# Am I root? If so, switch to asterisk and exit
if [[ "$SU" ]]; then
	SELF=$(readlink -f $0)
	$SU $SELF &
else
	# I am running as asterisk, so I can now loop restarting
	# restapps if it crashes.
	while :; do
		sleep 2
		$PHP < /dev/null &> /dev/null
		EXIT=$?
		# If we exited with 2, then we're authoritatively shutting down
		if [ $EXIT == 2 ]; then
			exit
		fi
	done &
fi
