<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
?>

<form method="post" name="sysadminVPNserver" id="sysadminVPNserver"  class="fpbx-submit" action="">
<input type="hidden" name="action" value="save_vpnserver">
<!--Enabled-->
<div class="element-container">
	<div class="row">
		<div class="form-group">
			<div class="col-md-3">
				<label class="control-label" for="enabled"><?php echo _("Enabled") ?></label>
			</div>
			<div class="col-md-9 radioset">
				<input type="radio" name="enabled" id="eyes" value="1" <?php echo ($vpnserver['enabled'] ? 'checked' : '') ?>/> 
				<label for="eyes"><?php echo _("Yes")?></label>
				<input type="radio" name="enabled" id="eno" value="0" <?php echo ($vpnserver['enabled'] ? '' : 'checked') ?>/> 
				<label for="eno"><?php echo _("No")?></label>
			</div>
		</div>
	</div>
</div>
<!--END Enabled-->
<!--Server Range-->
<div class="element-container">
	<div class="row">
		<div class="form-group">
			<div class="col-md-3">
				<label class="control-label" for="range"><?php echo _("Server Range") ?></label>
				<i class="fa fa-question-circle fpbx-help-icon" data-for="range"></i>
			</div>
			<div class="col-md-9">
				<textarea class="form-control" name="range"><?php echo $vpnserver['range'] ?></textarea>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="range-help" class="help-block fpbx-help-block"><?php echo _('Address range with netmask for OpenVPN server and connecting clients. (e.g. 10.8.0.0/255.255.255.0)  Note: If this changes, any addresses assigned to clients will be removed.')?></span>
		</div>
	</div>
</div>
<!--END Server Range-->
<!--Server Remote Address-->
<div class="element-container">
	<div class="row">
		<div class="form-group">
			<div class="col-md-3">
				<label class="control-label" for="serverremote"><?php echo _("Server Remote Address") ?></label>
				<i class="fa fa-question-circle fpbx-help-icon" data-for="serverremote"></i>
			</div>
			<div class="col-md-9">
				<textarea class="form-control" name="serverremote"><?php echo !empty($vpnserver['serverremote']) ? $vpnserver['serverremote'] : FreePBX::Sysadmin()->getExternalIP() ?></textarea>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="serverremote-help" class="help-block fpbx-help-block"><?php echo _('Address (IP or FQDN) at which the OpenVPN server is reachable for connecting clients.')?></span>
		</div>
	</div>
</div>
<!--END Server Remote Address->
<!--Redirect Gateway-->
<div class="element-container">
	<div class="row">
		<div class="form-group">
			<div class="col-md-3">
				<label class="control-label" for="redirgateway"><?php echo _("Redirect Gateway") ?></label>
				<i class="fa fa-question-circle fpbx-help-icon" data-for="redirgateway"></i>
			</div>
			<div class="col-md-9 radioset">
				<input type="radio" name="redirgateway" id="rgyes" value="1" <?php echo ($vpnserver['redirgateway'] ? 'checked' : '') ?>/> 
				<label for="rgyes"><?php echo _("Yes")?></label>
				<input type="radio" name="redirgateway" id="rgno" value="0" <?php echo ($vpnserver['redirgateway'] ? '' : 'checked') ?>/> 
				<label for="rgno"><?php echo _("No")?></label>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="redirgateway-help" class="help-block fpbx-help-block"><?php echo _('Force all client traffic through this OpenVPN server.')?></span>
		</div>
	</div>
</div>
<!--END Redirect Gateway-->
<!--Routes-->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="panel panel-default">
				<div class="panel-heading">
					<h3 class="panel-title"><?php echo _("Routes")?></h3>
				</div>
				<div class="panel-body">
					<table class="table table-striped">
						<tr>
							<th>
								<?php echo _('IP Address')?>
							</th>
							<th>
								<?php echo _('Netmask')?>
							</th>
							<th>
								<?php echo _('Enabled')?>
							</th>
						</tr>
						<?php
						$id = 0;
						foreach ($routes as $route) {
						?>
							<tr>
								<td><?php echo $route['ip']?></td>
								<td><?php echo $route['netmask']?></td>
								<td>
									<div class="form-group">
										<div class="col-md-3 radioset">
										<?php
											$enabled = !(array_search($route, $vpnserver['routes']) === false);
										?>
											<input type="radio" name="routes[<?php echo $id?>]" id="routesyes<?php echo $id ?>" value="<?php echo $route['ip'] . '/' . $route['netmask']?>" <?php echo ($enabled ? 'checked' : '') ?>/> 
											<label style='max-width: none' for="routesyes<?php echo $id?>"><?php echo _("Yes")?></label>
											<input type="radio" name="routes[<?php echo $id?>]" id="routesno<?php echo $id ?>" value="" <?php echo ($enabled ? '' : 'checked') ?>/> 
											<label style='max-width: none' for="routesno<?php echo $id?>"><?php echo _("No")?></label>
										</div>
									</div>
								</td>
							</tr>
						<?php
							$id++;
						} ?>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>
<!--END Routes-->
</form>
