<?php
/**
 * This is the User Control Panel Object.
 *
 * Copyright (C) 2016 Sangoma Communications
 *
 */
namespace UCP\Modules;
use \UCP\Modules as Modules;
class Vmnotify extends Modules{
	protected $module = 'Vmnotify';
	function __construct($Modules) {
		$this->Modules = $Modules;
		$this->user = $this->UCP->User->getUser();
		$this->enabled = $this->UCP->getCombinedSettingByID($this->user['id'],$this->module,'enabled');
	}

  public function getSettingsDisplay($ext) {
    $vars = array();
    if(!$this->enabled){
      return array();
    }
    $notif = $this->UCP->FreePBX->Vmnotify->getNotification($_REQUEST['sub']);
    if(empty($notif)){
      return array();
    }
    $vars['enabled'] = $notif[0]['enabled'];
    $vars['recipients'] = $this->UCP->FreePBX->Vmnotify->recipientsToText(unserialize($notif[0]['recipients']));
    $out = array(
      array(
        "title" => _('Voicemail Notifications'),
        "content" => $this->load_view(__DIR__.'/views/settings.php',$vars),
        "size" => 6
      )
    );
    return $out;
  }
  public function ajaxRequest($command,$settings){
    switch($command) {
      case 'settings':
        return true;
      default:
        return false;
      break;
    }
  }
  public function ajaxHandler(){
    switch($_REQUEST['command']){
      case 'settings':
        if(isset($_REQUEST['key']) && isset($_REQUEST['value']) && isset($_REQUEST['ext'])){
          switch ($_REQUEST['key']) {
            case 'vmnenable':
              if($_REQUEST['value'] === 'true'){
                $ret = $this->UCP->FreePBX->Vmnotify->enableVmnotify($_REQUEST['ext']);
                $mode = _("Enabled");
              }else{
                $ret = $this->UCP->FreePBX->Vmnotify->disableVmnotify($_REQUEST['ext']);
                $mode = _("Disabled");
              }
              if($ret > 0){
                return array("status" => true, "message" => sprintf(_("VMNotify for %s has been %s"), $_REQUEST['ext'],$mode));
              }else {
                return array("status" => false, "message" => _("Failed to update VMNotify"));
              }
            break;
            case 'vmnrecip':
              $ret = $this->UCP->FreePBX->Vmnotify->updateRecipients($_REQUEST['ext'],$_REQUEST['value']);
              if($ret > 0){
                return array("status" => true, "message" => sprintf(_("Recipients for %s have been updated"), $_REQUEST['ext']));
              }else {
                return array("status" => false, "message" => _("Failed to update VMNotify recipients"));
              }
            break;
            default:
              # code...
              break;
          }

        }
      break;
      default:
        return array("status" => false, "message" => "");
      break;
    }
  }
}
