<?php
/**
* https://blogs.kent.ac.uk/webdev/2011/07/14/phpunit-and-unserialized-pdo-instances/
* @backupGlobals disabled
*/
class VQGetterSetterTest extends PHPUnit_Framework_TestCase{
  //Will be FreePBX BMO object
	protected static $f;
	//Will become your Class object
	protected static $o;
	//Module name used in test output as self::$module. Can be anything unless you want to use this as something more.
	protected static $module = 'Vqplus';
	//Change Moduleclass to your class name
	public static function setUpBeforeClass() {
		include 'setuptests.php';
		self::$f = FreePBX::create();
		self::$o = self::$f->Vqplus;
	}
	public function setup() {
    $var = array();
    $var['name'] = "UTestCallback";
    $var['cid'] = "UNITTEST";
    $var['numprepend'] = '11';
    $var['patterns'] = 'xx';
    $var['announcement'] = 'announce';
    $var['recordname'] = 'recname';
    $var['promptreqnum'] = '1';
    $var['promptreqname'] = '1';
    $var['promptreqconfirm'] = '1';
    $var['promptcb'] = '1';
    $var['promptcbaccept'] = '1';
    $var['cbqueue'] = '1';
    $var['timeout'] = 3;
    $var['retries'] = 3;
    $var['retrydelay'] = 3;
    $var['maxcallbacks'] = 1;
    $this->callback = $var;
    $this->id = '';

  }

	public function testPHPUnit() {
		$this->assertEquals("test", "test", "PHPUnit is broken.");
		$this->assertNotEquals("test", "nottest", "PHPUnit is broken.");
	}
	//This tests that the the BMO object for your class is an object
	public function testCreate() {;
		$this->assertTrue(is_object(self::$o), sprintf("Did not get a %s object",self::$module));
	}
	//This can be renamed to anything. Any method starting with "test" will be a test
	public function testSave(){
	  $this->id = \vqplus_callback_save($this->callback);
    $this->assertTrue(is_string($this->id), "Got a " . gettype($this->id) . " instead of a string");
	}
  public function testGet(){
    $return = self::$o->getCallback($this->id);
    $this->callback['id'] = $this->id;
    $this->assertEquals(0, count(array_diff($return, $this->callback)));
  }
  public function testDel(){
    $ret = \vqplus_callback_del($this->id);
    $this->assertTrue($ret, "Failed to delete");
  }
}
