<?php
function zulu_configpageinit($dispnum) {
	global $currentcomponent;
	global $amp_conf;

	if ( ($dispnum == 'users' || $dispnum == 'extensions') ) {
		$action			= isset($_REQUEST['action'])		? $_REQUEST['action']			: null;
		$extdisplay		= isset($_REQUEST['extdisplay'])	? $_REQUEST['extdisplay']		: null;
		$extension		= isset($_REQUEST['extension'])		? $_REQUEST['extension']		: null;
		$tech_hardware	= isset($_REQUEST['tech_hardware'])	? $_REQUEST['tech_hardware']	: null;
		if ($tech_hardware != null || $action == "add" || $extdisplay != '') {
			zulu_users_configpageinit($dispnum);
		}
	}
}
function zulu_users_configpageinit($pagename) {
	global $currentcomponent;
	global $astman;
	$display = isset($_REQUEST['display'])?$_REQUEST['display']:null;
	$action = isset($_REQUEST['action'])?$_REQUEST['action']:null;
	$extdisplay = isset($_REQUEST['extdisplay'])?$_REQUEST['extdisplay']:null;
	$extension = isset($_REQUEST['extension'])?$_REQUEST['extension']:null;
	$tech_hardware = isset($_REQUEST['tech_hardware'])?$_REQUEST['tech_hardware']:null;

	// We only want to hook the 'extensions' pages.
	if ($pagename != 'extensions' && $pagename != 'users')  {
		return true;
	}

	// On a 'new' user, 'tech_hardware' is set, and there's no extension. Hook into the page.
	if ($tech_hardware != null || $pagename == 'users') {
		$currentcomponent->addguifunc('zulu_users_configpageload');
		$currentcomponent->addprocessfunc('zulu_users_configprocess', 8);
	} elseif ($action=="add") {
		// We don't need to display anything on an 'add', but we do need to handle returned data.
		$currentcomponent->addprocessfunc('zulu_users_configprocess', 8);
	} elseif ($extdisplay != '') {
		// We're now viewing an extension, so we need to display _and_ process.
		$currentcomponent->addguifunc('zulu_users_configpageload');
		$currentcomponent->addprocessfunc('zulu_users_configprocess', 8);
	}
}
function zulu_users_configpageload($pagename) {
	global $currentcomponent;
	global $astman;
	global $extdisplay;
	$category = "zulu";
	$guidefaults = array(
		"elemname" => "",
		"prompttext" => "",
		"helptext" => "",
		"currentvalue" => "",
		"valarray" => array(),
		"jsonclick" => '',
		"jsvalidation" => "",
		"failvalidationmsg" => "",
		"canbeempty" => false,
		"maxchars" => 0,
		"disable" => false,
		"inputgroup" => false,
		"class" => "",
		"cblabel" => 'Enable',
		"disabled_value" => 'DEFAULT',
		"check_enables" => 'true',
		"cbdisable" => false,
		"cbclass" => ''
	);

	$type = '';
	$url = '';
	$aa = 'yes';
	if(isset($extdisplay)) {
		$type = $astman->database_get("ZULU/".$extdisplay,"TYPE");
		$url = $astman->database_get("ZULU/".$extdisplay,"URL");
		$aa = $astman->database_get("ZULU/".$extdisplay,"AUTOANSWER");
		if(empty($aa)) {
			$aa = 'yes';
			$astman->database_put("ZULU/".$extdisplay,"AUTOANSWER","yes");
		}
	}

	$currentcomponent->addTabTranslation($category, "Zulu");

	$options = array(
		array(
			"value" => "",
			"text" => _("Inherit")
		),
		array(
			"value" => "contact",
			"text" => _("Link to Contact")
		),
		array(
			"value" => "url",
			"text" => _("Link to URL")
		),
	);

	$section = _("General Settings");
	$el = array(
		"elemname" => "zulucall",
		"prompttext" => _('Default On Call Popup'),
		"helptext" => _("When a call through this route hits a Zulu client this setting determines what happens when the user clicks the desktop popup. Choices are: <ul><li>Link to Contact: Will bring up the associated contact to the Caller ID Number through the desktop Address Book</li><li>Link to URL: Will execute a URL listed below in the default desktop browser</li></ul>"),
		"currentvalue" => $type,
		"valarray" => $options,
	);
	$currentcomponent->addguielem($section, new gui_selectbox(array_merge($guidefaults,$el)), $category);

	$el = array(
		"elemname" => "zuluurl",
		"prompttext" => _("Default URL for 'Link to URL'"),
		"helptext" => _('URL to execute when a call popup is clicked on the desktop client. Any Asterisk channel variables can be passed, examples of common variables are: <ul><li>${CALLERID(name)}: Inbound CallerID Number</li><li>${CALLERID(num)}: Inbound CallerID Name</li></ul>'),
		"currentvalue" => $url,
		"canbeempty" => true,
		"class" => "",
	);
	$currentcomponent->addguielem($section, new gui_textbox(array_merge($guidefaults,$el)),$category);

	$currentcomponent->addoptlistitem('zyn', 'yes', _('Yes'));
	$currentcomponent->addoptlistitem('zyn', 'no', _('No'));
	$currentcomponent->setoptlistopts('zyn', 'sort', false);

	if(FreePBX::Modules()->checkStatus("paging")) {
		$el = array(
			"elemname" => "zuluautoanswer",
			"prompttext" => _("Enable Auto Answer for Origination"),
			"helptext" => _("If set to yes when originating calls from Zulu the Zulu extension will automatically answer. This eliminates the need to answer the local extension to bridge the call. Default is yes"),
			"currentvalue" => $aa,
			"valarray" => $currentcomponent->getoptlist('zyn'),
			"pairedvalues" => false
		);
		$currentcomponent->addguielem($section, new gui_radio(array_merge($guidefaults,$el)),$category);
	}
}

function zulu_users_configprocess() {
	global $currentcomponent;
	global $amp_conf;
	global $astman;

	//create vars from the request
	$action = isset($_REQUEST['action'])?$_REQUEST['action']:null;
	$ext = isset($_REQUEST['extdisplay'])?$_REQUEST['extdisplay']:null;
	$extn = isset($_REQUEST['extension'])?$_REQUEST['extension']:null;

	if ($ext=='') {
		$extdisplay = $extn;
	} else {
		$extdisplay = $ext;
	}

	switch($action) {
		case "add":
		case "edit":
			$url = $_REQUEST["zuluurl"];
			$parsed = parse_url($url);
			if (!empty($url) && empty($parsed['scheme'])) {
				$url = 'http://' . ltrim($url, '/');
			}
			$astman->database_put("ZULU/".$extdisplay,"TYPE",$_REQUEST["zulucall"]);
			$astman->database_put("ZULU/".$extdisplay,"URL",$url);
			if(FreePBX::Modules()->checkStatus("paging")) {
				$aa = $_REQUEST['zuluautoanswer'];
				$astman->database_put("ZULU/".$extdisplay,"AUTOANSWER",$aa);
			}
		break;
	}
}

function zulu_hook_ringgroups($viewing_itemid, $module_page) {
	if(!FreePBX::Zulu()->licensed()) {
		return array();
	}
	$ret = array();
	if(isset($_REQUEST['extdisplay'])) {
		$settings = FreePBX::Zulu()->getConfig("ringgroups-settings");
	}
	$id = str_replace("GRP-","",$_REQUEST['extdisplay']);
	if(!isset($settings[$id])) {
		$settings = array(
			"call" => "",
			"url" => ""
		);
	} else {
		$settings = $settings[$id];
	}
	return load_view(__DIR__."/views/ringgroups_hook.php",array("zsettings" => $settings));
}
