<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="zulucall"><?php echo _("Zulu On Call Popup")?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="zulucall"></i>
					</div>
					<div class="col-md-9">
						<select id="zulucall" name="zulucall" class="form-control">
							<option value="" <?php echo ($zsettings['call'] == "") ? "selected" : ""?>><?php echo _("Do Nothing")?></option>
							<option value="contact" <?php echo ($zsettings['call'] == "contact") ? "selected" : ""?>><?php echo _("Link to Contact")?></option>
							<option value="url" <?php echo ($zsettings['call'] == "url") ? "selected" : ""?>><?php echo _("Link to URL")?></option>
						</select>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="zulucall-help" class="help-block fpbx-help-block"><?php echo _("When a call through this route hits a Zulu client this setting determines what happens when the user clicks the desktop popup. Choices are: <ul><li>Link to Contact: Will bring up the associated contact to the Caller ID Number through the desktop Address Book</li><li>Link to URL: Will execute a URL listed below in the default desktop browser</li></ul>")?></span>
		</div>
	</div>
</div>
<div class="element-container <?php echo ($zsettings['call'] != "url") ? "hidden" : ""?>" id="zuluurl-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="zuluurl"><?php echo _("Zulu URL for 'Link to URL'")?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="zuluurl"></i>
					</div>
					<div class="col-md-9">
						<input name="zuluurl" id="zuluurl" class="form-control" value="<?php echo $zsettings['url']?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="zuluurl-help" class="help-block fpbx-help-block"><?php echo _('URL to execute when a call popup is clicked on the desktop client. Any Asterisk channel variables can be passed, examples of common variables are: <ul><li>${CALLERID(name)}: Inbound CallerID Number</li><li>${CALLERID(num)}: Inbound CallerID Name</li></ul>')?></span>
		</div>
	</div>
</div>
<script>
$("#zulucall").change(function() {
	if($(this).val() == "url") {
		$("#zuluurl-container").removeClass("hidden");
	} else {
		$("#zuluurl-container").addClass("hidden");
	}
});
</script>
